# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](http://keepachangelog.com/en/1.0.0/)
and this project adheres to [Semantic Versioning](http://semver.org/spec/v2.0.0.html).

Generated by [`auto-changelog`](https://github.com/CookPete/auto-changelog).

## [1.15.2] - 2019-02-22
### Changed
- `map` property is not a `Leaflet` object anymore. Instead it will be a native object.

## [1.15.1] - 2019-02-22
### Fixed
- Fixed a race condition in layer promise mangement where we stored an instance of the layer manager and this was a valid value for `Promise.all`, resolving the final promise sooner than expected. This issue was affecting specially to CartoDB layers.


## [1.15.0] - 2019-02-20
### Added
- Adds an `onReady` callback to layer-manager component. This function triggers when all layer fetchs are resolved. It returns the fetched layers.

### Fixed
 - Fixes regression [249c64def8feea112296e9e65b07b2de953d82e0](https://github.com/Vizzuality/layer-manager/commit/249c64def8feea112296e9e65b07b2de953d82e0)
	where `onLayerLoading` was removed.

## [v1.0.2](https://github.com/Vizzuality/layer-manager/compare/v1.0.1...v1.0.2) - 2018-07-30

### Commits

- Layer: onLayerLoading implemented [`f755303`](https://github.com/Vizzuality/layer-manager/commit/f7553038ec0e0e21ba93482a9566772a343716f1)

## [v1.0.1](https://github.com/Vizzuality/layer-manager/compare/v1.0.0...v1.0.1) - 2018-07-26

### Merged

- Feature/engine fix [`#13`](https://github.com/Vizzuality/layer-manager/pull/13)

### Commits

- Update remove function [`dda9de3`](https://github.com/Vizzuality/layer-manager/commit/dda9de3b8e8f0f1b0fe50dd250a2f4031d107529)
- up version [`8d4e9d5`](https://github.com/Vizzuality/layer-manager/commit/8d4e9d5d200dc5b7962d47e66d9bd7d4c3dc87bc)
- updating engine requirement [`ce7592d`](https://github.com/Vizzuality/layer-manager/commit/ce7592d291bce81f9a8d38e0dbc9fa41a3b49d33)

## [v1.0.0](https://github.com/Vizzuality/layer-manager/compare/v0.1.5...v1.0.0) - 2018-07-24

### Merged

- Feature/params [`#12`](https://github.com/Vizzuality/layer-manager/pull/12)
- Feat: plugin cesium [`#11`](https://github.com/Vizzuality/layer-manager/pull/11)
- Feature/redraw canvas [`#8`](https://github.com/Vizzuality/layer-manager/pull/8)
- move layerManager init to constructor [`#10`](https://github.com/Vizzuality/layer-manager/pull/10)
- Canvas: redraw functionality [`#7`](https://github.com/Vizzuality/layer-manager/pull/7)

### Commits

- Convert layerConfig with params and sqlParams [`0e449b5`](https://github.com/Vizzuality/layer-manager/commit/0e449b5055a617b1fc72f27e604055d3c4a8f072)
- add imoport resolver + small fixes to plugin cesium [`5e304fd`](https://github.com/Vizzuality/layer-manager/commit/5e304fd5817a6f9ebfb21ce39416fc6af04d0136)
- Canvas: tileParams and tileUrl for better performance [`2757f1c`](https://github.com/Vizzuality/layer-manager/commit/2757f1ca3c4581dffe87cef258ef33a410e0888b)
- Layers responding to params [`53cb8a3`](https://github.com/Vizzuality/layer-manager/commit/53cb8a32e5786c3d1e83ad589ea22984ce7317e5)
- feat: includes new plugin for cesium [`8dbeeb3`](https://github.com/Vizzuality/layer-manager/commit/8dbeeb33182c87cdffff444d055808a2ba328a29)
- restructure plugins [`66a771c`](https://github.com/Vizzuality/layer-manager/commit/66a771c036efd2c671dd2f4374fafde562bd1b1d)
- docs update [`2a95239`](https://github.com/Vizzuality/layer-manager/commit/2a952391b1766109f47776e2eb99a7655e5e129c)
- spelling mistake and check for events when removing [`fdc1db9`](https://github.com/Vizzuality/layer-manager/commit/fdc1db9ec43a86ebdc314232f0a3d0475130393c)
- prettify code examples [`df8031f`](https://github.com/Vizzuality/layer-manager/commit/df8031f48dece90e315a130c02c50d120d6bdd59)
- set decode options when props change [`5042ce1`](https://github.com/Vizzuality/layer-manager/commit/5042ce15513f9b656ff7005e030ebe7960e30eef)
- react export from [`7028550`](https://github.com/Vizzuality/layer-manager/commit/70285505df657a0038d53e0d1617db04e789606f)
- add default dataMaxZoom for canvas, fix body url parsing [`1739c60`](https://github.com/Vizzuality/layer-manager/commit/1739c6002099f12566c88fdf694d14196136c52d)
- fix: setZIndex [`9257370`](https://github.com/Vizzuality/layer-manager/commit/925737093f96c4f37d3c42f51db07bcbdcedff73)
- Update version [`659d5bb`](https://github.com/Vizzuality/layer-manager/commit/659d5bb16e1575b067c0bdf2a8be0e9e0a58051c)

## [v0.1.5](https://github.com/Vizzuality/layer-manager/compare/v0.1.4...v0.1.5) - 2018-07-12

### Merged

- Canvas: layer and decode function added [`#6`](https://github.com/Vizzuality/layer-manager/pull/6)
- Feature/layer manager and layer component [`#5`](https://github.com/Vizzuality/layer-manager/pull/5)

### Commits

- layer manager and layer components [`db26a58`](https://github.com/Vizzuality/layer-manager/commit/db26a582fd90f83722473474fc999993d4897f61)
- remove proptypes for now [`bb7bf8d`](https://github.com/Vizzuality/layer-manager/commit/bb7bf8da245cd0040ac7d68392ae61d608d040f5)
- update readme [`5e82396`](https://github.com/Vizzuality/layer-manager/commit/5e8239689b25565f0c8d45e0b48131cd99850d71)
- Update README.md [`68ed552`](https://github.com/Vizzuality/layer-manager/commit/68ed552e117a4fe5658600b6fafd491011cae704)
- Update README.md [`55af3c8`](https://github.com/Vizzuality/layer-manager/commit/55af3c81aa9d8223f02a7eeadf63a7ca3e062a71)
- fix: pure component to component [`193c308`](https://github.com/Vizzuality/layer-manager/commit/193c30880e55b7f68e71df6b43ff882fe5c50e96)
- Update README.md [`e4846d9`](https://github.com/Vizzuality/layer-manager/commit/e4846d9333ac57ef7b30aa18435dbd588f7e089b)

## [v0.1.4](https://github.com/Vizzuality/layer-manager/compare/v0.1.3...v0.1.4) - 2018-07-11

### Commits

- LOCA & NEXGDDP fixes [`ecbc5d2`](https://github.com/Vizzuality/layer-manager/commit/ecbc5d2cd996a1cfe180f95dfbae102cf008a235)

## v0.1.3 - 2018-07-11

### Merged

- Support for gee layer [`#4`](https://github.com/Vizzuality/layer-manager/pull/4)
- Carto: interactivity [`#3`](https://github.com/Vizzuality/layer-manager/pull/3)
- Fix: render layers method. Cancel promises. Esri z-index [`#2`](https://github.com/Vizzuality/layer-manager/pull/2)
- Restructuring [`#1`](https://github.com/Vizzuality/layer-manager/pull/1)

### Commits

- New type of layers [`404b290`](https://github.com/Vizzuality/layer-manager/commit/404b2909d70feac30b6564754f0f0b90c6f41aa9)
- Promise from bluebird [`2d02275`](https://github.com/Vizzuality/layer-manager/commit/2d0227589740adffa7bd0556e6b9acc66e9784b2)
- Remove unnecessary code [`fc736cd`](https://github.com/Vizzuality/layer-manager/commit/fc736cdff1a9f2b61d2ce095e65586db08e5d9a5)
- Readme updated [`d703af3`](https://github.com/Vizzuality/layer-manager/commit/d703af32fe725a7317bc549629fd0917a386476b)
- added support for leaflet and gee layer [`ad4a89b`](https://github.com/Vizzuality/layer-manager/commit/ad4a89b211d89cf80858fad43b0864ba48d9f841)
- Release [`dc0117f`](https://github.com/Vizzuality/layer-manager/commit/dc0117f89921149b0a5a2c10b1cde15810b7d9a4)
- Fix: render layers method. Cancel promises. Esri zIndex [`90ed678`](https://github.com/Vizzuality/layer-manager/commit/90ed6782b16e4595e431390dd90033536d50788c)
- README updated [`6f8713d`](https://github.com/Vizzuality/layer-manager/commit/6f8713d5d57f3237ec17cb455546ff38eebf77cf)
- Layer Manager: improvements [`9bdbda9`](https://github.com/Vizzuality/layer-manager/commit/9bdbda9d74550382850d8c330b1883f16bcea322)
- Fix remove leaflet layers [`690814f`](https://github.com/Vizzuality/layer-manager/commit/690814fd739a61ce28292a943d3417c67cd78ebe)
- Using plugins [`d6f322a`](https://github.com/Vizzuality/layer-manager/commit/d6f322a9d1b6722fb0ab43c380cbc5773db43c7c)
- Typo fixes [`848f437`](https://github.com/Vizzuality/layer-manager/commit/848f437301cee20e65b92dce57f91abe665128fb)
- remove debugger [`a8913b8`](https://github.com/Vizzuality/layer-manager/commit/a8913b854645164ec70c7bc9e0f62a211dd25dfe)
- allow all layers to be removed [`9648311`](https://github.com/Vizzuality/layer-manager/commit/9648311924fb17be7ac6c6cd6ce859b9cb7caa50)
- update google maps render function to correct name [`dbdb85b`](https://github.com/Vizzuality/layer-manager/commit/dbdb85b1f05f1376e8f9adadaa4412d3adb82aeb)
- fix spreading of options from constructor [`8ab75b0`](https://github.com/Vizzuality/layer-manager/commit/8ab75b09e8fcbf78f1f8a7e87f27d4b1627b1674)
- make watchify verbose, fix bundle.js in main [`88fdd2f`](https://github.com/Vizzuality/layer-manager/commit/88fdd2f1bcfa0e12d6ce9d230d80f25fc3de7615)
- new version: adding support for only one layer [`9c06bca`](https://github.com/Vizzuality/layer-manager/commit/9c06bca1f727eb55dd7f87eec5bd261b0b5c0083)
- abort fetch [`2e98ce7`](https://github.com/Vizzuality/layer-manager/commit/2e98ce75d1d3874160b7273bc3eb7f289a9f8448)
- Update .npmignore [`35c3ab8`](https://github.com/Vizzuality/layer-manager/commit/35c3ab8d446bb198f47c7fda5d35f7da73bfe0dc)
- added carto and esri [`fd15ad5`](https://github.com/Vizzuality/layer-manager/commit/fd15ad5030df049bff01d3c3e1d48e334785df72)
- added support for esri layers [`934ccd2`](https://github.com/Vizzuality/layer-manager/commit/934ccd240d4d97c1f92e2747711da7a2fa60d72d)
- fixing serialize by defaul [`4fa5656`](https://github.com/Vizzuality/layer-manager/commit/4fa5656e9450c2af86ba438a68757ace24aba2fa)
- working with opacity, visibility and zindex [`2348234`](https://github.com/Vizzuality/layer-manager/commit/2348234799ffea168d461857f26a2e8586217720)
- removed abort from model [`761f17a`](https://github.com/Vizzuality/layer-manager/commit/761f17a2e2e37995168a8a13f89e2a7c44f87f0e)
- carto layer working [`b6367cf`](https://github.com/Vizzuality/layer-manager/commit/b6367cf7a54d9a1d902ac65fb87b68bf26a697e5)
- test passed [`0617ed1`](https://github.com/Vizzuality/layer-manager/commit/0617ed180d2696adbf7c8aaa14abb4cf5e8e5d8c)
- added abort service [`175c422`](https://github.com/Vizzuality/layer-manager/commit/175c4221efad758aa7f2df7147823c834d2ac52e)
- resolving eslint [`5e81f33`](https://github.com/Vizzuality/layer-manager/commit/5e81f33f9ab20216be06e721f5047a032314838a)
- layer model [`8ff4fb1`](https://github.com/Vizzuality/layer-manager/commit/8ff4fb1b5c4e3007e3e020807c3ebee92c2758df)
- added layer model [`4f1e522`](https://github.com/Vizzuality/layer-manager/commit/4f1e52238cc6cd320c47ab20ce81b9941cb11ca8)
- added layer model [`df384b5`](https://github.com/Vizzuality/layer-manager/commit/df384b5e0b350e0570207e9f665f48385f0dc6bb)
- better way to get methods for layer [`e8529a2`](https://github.com/Vizzuality/layer-manager/commit/e8529a20e59d8a5f13a1cdceab531988d44f00b8)
- added test [`792b73c`](https://github.com/Vizzuality/layer-manager/commit/792b73c7a679ba978b311fb09f32445b288b31a0)
- added find [`2b5eef6`](https://github.com/Vizzuality/layer-manager/commit/2b5eef6312f8a0089efa72964bb5e7e5f77f37c7)
- adding method for layer manager [`246979d`](https://github.com/Vizzuality/layer-manager/commit/246979d5f45377b40d51d4ed7690a5aa4cb26d96)
- addind layer spec [`4fa528e`](https://github.com/Vizzuality/layer-manager/commit/4fa528e6d303d8f197db9da1378aca04103da34d)
- Update README.md [`78df326`](https://github.com/Vizzuality/layer-manager/commit/78df326faf23725bbb08137ec52c1620cfffda6a)
- update readme [`53e5e5a`](https://github.com/Vizzuality/layer-manager/commit/53e5e5a1389539b1518e9fbc101d7aa81cf9ea80)
- first commit [`4c508a2`](https://github.com/Vizzuality/layer-manager/commit/4c508a2c26599d40e4a2bed1044857a1c8ca4e30)
