(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('axios'), require('lodash/compact'), require('@luma.gl/constants'), require('@deck.gl/core'), require('luma.gl'), require('@loaders.gl/images'), require('viewport-mercator-project'), require('deck.gl'), require('@deck.gl/mapbox'), require('lodash/sortBy'), require('lodash/isEqual'), require('lodash/isEmpty')) :
  typeof define === 'function' && define.amd ? define(['axios', 'lodash/compact', '@luma.gl/constants', '@deck.gl/core', 'luma.gl', '@loaders.gl/images', 'viewport-mercator-project', 'deck.gl', '@deck.gl/mapbox', 'lodash/sortBy', 'lodash/isEqual', 'lodash/isEmpty'], factory) :
  (global.LayerManager = factory(global.axios,global.compact,global['@luma']['gl/constants'],global['@deck']['gl/core'],global.luma.gl,global['@loaders']['gl/images'],global['viewport-mercator-project'],global.deck.gl,global['@deck']['gl/mapbox'],global.sortBy,global.isEqual,global.isEmpty));
}(this, (function (axios,compact,GL,core,luma_gl,images,viewportMercatorProject,deck_gl,mapbox,sortBy,isEqual,isEmpty) { 'use strict';

  var axios__default = 'default' in axios ? axios['default'] : axios;
  compact = compact && compact.hasOwnProperty('default') ? compact['default'] : compact;
  GL = GL && GL.hasOwnProperty('default') ? GL['default'] : GL;
  sortBy = sortBy && sortBy.hasOwnProperty('default') ? sortBy['default'] : sortBy;
  isEqual = isEqual && isEqual.hasOwnProperty('default') ? isEqual['default'] : isEqual;
  isEmpty = isEmpty && isEmpty.hasOwnProperty('default') ? isEmpty['default'] : isEmpty;

  var classCallCheck = function (instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  };

  var createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  var defineProperty = function (obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  };

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  var get = function get(object, property, receiver) {
    if (object === null) object = Function.prototype;
    var desc = Object.getOwnPropertyDescriptor(object, property);

    if (desc === undefined) {
      var parent = Object.getPrototypeOf(object);

      if (parent === null) {
        return undefined;
      } else {
        return get(parent, property, receiver);
      }
    } else if ("value" in desc) {
      return desc.value;
    } else {
      var getter = desc.get;

      if (getter === undefined) {
        return undefined;
      }

      return getter.call(receiver);
    }
  };

  var inherits = function (subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  };

  var possibleConstructorReturn = function (self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  };

  var slicedToArray = function () {
    function sliceIterator(arr, i) {
      var _arr = [];
      var _n = true;
      var _d = false;
      var _e = undefined;

      try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);

          if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;
        _e = err;
      } finally {
        try {
          if (!_n && _i["return"]) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }

      return _arr;
    }

    return function (arr, i) {
      if (Array.isArray(arr)) {
        return arr;
      } else if (Symbol.iterator in Object(arr)) {
        return sliceIterator(arr, i);
      } else {
        throw new TypeError("Invalid attempt to destructure non-iterable instance");
      }
    };
  }();

  var headers = {
    'Content-Type': 'application/json'
  };

  var get$1 = function get$$1(url) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return axios__default.get(url, _extends({
      headers: headers
    }, options));
  };

  /**
   * Params should have this format => { key:'xxx', key2:'xxx' }
   * Keys to search should be in this format {{key}}
   * @param {String} originalStr
   * @param {Object} params
   */
  var substitution = function substitution(originalStr) {
    var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var str = originalStr;
    Object.keys(params).forEach(function (key) {
      str = str.replace(new RegExp('{{' + key + '}}', 'g'), params[key]).replace(new RegExp('{' + key + '}', 'g'), params[key]);
    });
    return str;
  };

  /**
   * Params should have this format => { where1: { { key:'xxx', key2:'xxx' } }},
   * Keys to search should be in this format {{key}}
   * @param {String} originalStr
   * @param {Object} params
   */
  var concatenation = function concatenation(originalStr) {
    var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var str = originalStr;
    var sql = void 0;

    Object.keys(params).forEach(function (key) {
      sql = '' + compact(Object.keys(params[key]).map(function (k) {
        var value = params[key][k];

        if (Array.isArray(value) && !!value.length) {
          var mappedValue = value.map(function (v) {
            return typeof v !== 'number' ? '\'' + v + '\'' : v;
          });
          return k + ' IN (' + mappedValue.join(', ') + ')';
        }

        if (!Array.isArray(value) && value) {
          return typeof value !== 'number' ? k + ' = \'' + value + '\'' : k + ' = ' + value;
        }

        return null;
      })).join(' AND ');

      if (sql && key.startsWith('where')) sql = 'WHERE ' + sql;else if (sql && key.startsWith('and')) sql = 'AND ' + sql;else sql = '';

      str = str.replace(new RegExp('{{' + key + '}}', 'g'), sql);
      str = str.replace(new RegExp('{' + key + '}', 'g'), sql);
    });

    return str;
  };

  /**
   * Replace function
   * @param {String} string
   * @param {Object} params
   * @param {Object} sqlParams
   */
  var replace = function replace(originalStr) {
    var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var sqlParams = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    var str = originalStr;

    if (typeof str === 'string') {
      str = substitution(str, params);
      str = concatenation(str, sqlParams);
    }

    return str;
  };

  var fetchTile = function fetchTile(layerModel) {
    var layerConfig = layerModel.layerConfig,
        params = layerModel.params,
        sqlParams = layerModel.sqlParams,
        interactivity = layerModel.interactivity;


    var layerConfigParsed = layerConfig.parse === false ? layerConfig : JSON.parse(replace(JSON.stringify(layerConfig), params, sqlParams));
    var layerTpl = JSON.stringify({
      version: '1.3.0',
      stat_tag: 'API',
      layers: layerConfigParsed.body.layers.map(function (l) {
        if (!!interactivity && interactivity.length) {
          return _extends({}, l, { options: _extends({}, l.options, { interactivity: interactivity }) });
        }
        return l;
      })
    });
    var apiParams = '?stat_tag=API&config=' + encodeURIComponent(layerTpl);
    var url = 'https://' + layerConfigParsed.account + '.carto.com/api/v1/map' + apiParams;

    var layerRequest = layerModel.layerRequest;

    if (layerRequest) {
      layerRequest.cancel('Operation canceled by the user.');
    }

    var layerRequestSource = axios.CancelToken.source();
    layerModel.set('layerRequest', layerRequestSource);

    var newLayerRequest = get$1(url, { cancelToken: layerRequestSource.token }).then(function (res) {
      if (res.status > 400) {
        console.error(res);
        return false;
      }

      return res.data;
    });

    return newLayerRequest;
  };

  var _ref = typeof window !== 'undefined' ? window : {},
      L = _ref.L;

  var CartoLayer = function CartoLayer(layerModel) {
    if (!L) throw new Error('Leaflet must be defined.');

    var layerConfig = layerModel.layerConfig,
        params = layerModel.params,
        sqlParams = layerModel.sqlParams,
        interactivity = layerModel.interactivity;

    var layerConfigParsed = layerConfig.parse === false ? layerConfig : JSON.parse(replace(JSON.stringify(layerConfig), params, sqlParams));

    return new Promise(function (resolve, reject) {
      fetchTile(layerModel).then(function (response) {
        var tileUrl = response.cdn_url.templates.https.url + '/' + layerConfigParsed.account + '/api/v1/map/' + response.layergroupid + '/{z}/{x}/{y}.png';
        var layer = L.tileLayer(tileUrl);

        // Add interactivity
        if (interactivity && interactivity.length) {
          var gridUrl = response.cdn_url.templates.https.url + '/' + layerConfigParsed.account + '/api/v1/map/' + response.layergroupid + '/0/{z}/{x}/{y}.grid.json';
          var interactiveLayer = L.utfGrid(gridUrl);

          var LayerGroup = L.LayerGroup.extend({
            group: true,
            setOpacity: function setOpacity(opacity) {
              layerModel.mapLayer.getLayers().forEach(function (l) {
                l.setOpacity(opacity);
              });
            }
          });

          return resolve(new LayerGroup([layer, interactiveLayer]));
        }

        return resolve(layer);
      }).catch(function (err) {
        return reject(err);
      });
    });
  };

  var _ref$1 = typeof window !== 'undefined' ? window : {},
      L$1 = _ref$1.L;

  var CanvasLayer = L$1 && L$1.GridLayer.extend({
    tiles: {},
    createTile: function createTile(_ref2, done) {
      var _this = this;

      var x = _ref2.x,
          y = _ref2.y,
          z = _ref2.z;
      var params = this.options.params;


      var id = replace(params.url, _extends({ x: x, y: y, z: z }, params));

      // Delete all tiles from others zooms;
      var tilesKeys = Object.keys(this.tiles);
      for (var i = 0; i < tilesKeys.length; i++) {
        if (this.tiles[tilesKeys[i]].z !== z) {
          delete this.tiles[tilesKeys[i]];
        }
      }

      // create a <canvas> element for drawing
      this.done = done;

      var tile = L$1.DomUtil.create('canvas', 'leaflet-tile');
      var ctx = tile.getContext('2d');
      var size = this.getTileSize();

      // setup tile width and height according to the options
      tile.width = size.x;
      tile.height = size.y;

      // getTile
      this.getTile({ x: x, y: y, z: z }).then(function (image) {
        _this.cacheTile(_extends({ id: id, tile: tile, ctx: ctx, image: image }, { x: x, y: y, z: z }));
        _this.drawCanvas(id);

        // return the tile so it can be rendered on screen
        done(null, tile);
      }).catch(function (err) {
        done(err, tile);
      });

      return tile;
    },
    getTile: function getTile(_ref3) {
      var _this2 = this;

      var x = _ref3.x,
          y = _ref3.y,
          z = _ref3.z;
      var _options = this.options,
          params = _options.params,
          sqlParams = _options.sqlParams;
      var url = params.url,
          _params$dataMaxZoom = params.dataMaxZoom,
          dataMaxZoom = _params$dataMaxZoom === undefined ? 20 : _params$dataMaxZoom;

      var zsteps = z - dataMaxZoom;
      var id = replace(params.url, _extends({ x: x, y: y, z: z }, params));

      var coords = { x: x, y: y, z: z };

      if (zsteps > 0) {
        coords = {
          x: Math.floor(x / Math.pow(2, zsteps)),
          y: Math.floor(y / Math.pow(2, zsteps)),
          z: dataMaxZoom
        };
      }

      var tileUrl = replace(url, _extends({}, coords, params), sqlParams);

      return new Promise(function (resolve, reject) {
        // Return cached tile if loaded.
        if (_this2.tiles[id]) {
          resolve(_this2.tiles[id].image);
        }

        var xhr = new XMLHttpRequest();

        xhr.addEventListener('load', function (e) {
          var response = e.currentTarget.response;

          var src = URL.createObjectURL(response);
          var image = new Image();

          image.src = src;

          image.onload = function () {
            image.crossOrigin = '';
            resolve(image);
            URL.revokeObjectURL(src);
          };

          image.onerror = function () {
            reject(new Error("Can't load image"));
          };
        });

        xhr.addEventListener('error', reject);

        xhr.open('GET', tileUrl, true);
        xhr.responseType = 'blob';
        xhr.send();
      });
    },
    cacheTile: function cacheTile(tile) {
      this.tiles[tile.id] = _extends({}, this.tiles[tile.id], tile);
    },
    drawCanvas: function drawCanvas(id) {
      'use asm';

      if (!this.tiles[id]) {
        return;
      }

      var _tiles$id = this.tiles[id],
          tile = _tiles$id.tile,
          ctx = _tiles$id.ctx,
          image = _tiles$id.image,
          x = _tiles$id.x,
          y = _tiles$id.y,
          z = _tiles$id.z;


      if (!tile || !ctx || !image || typeof x === 'undefined' || typeof y === 'undefined' || typeof z === 'undefined') {
        delete this.tiles[id];
        return;
      }

      var _options2 = this.options,
          params = _options2.params,
          decodeParams = _options2.decodeParams,
          decodeFunction = _options2.decodeFunction;
      var _params$dataMaxZoom2 = params.dataMaxZoom,
          dataMaxZoom = _params$dataMaxZoom2 === undefined ? 20 : _params$dataMaxZoom2;

      var zsteps = z - dataMaxZoom;

      // this will allow us to sum up the dots when the timeline is running
      ctx.clearRect(0, 0, tile.width, tile.width);

      if (zsteps < 0) {
        ctx.drawImage(image, 0, 0);
      } else {
        // over the maxzoom, we'll need to scale up each tile
        ctx.imageSmoothingEnabled = false;
        // disable pic enhancement
        ctx.mozImageSmoothingEnabled = false;

        // tile scaling
        var srcX = tile.width / Math.pow(2, zsteps) * (x % Math.pow(2, zsteps)) || 0;
        var srcY = tile.height / Math.pow(2, zsteps) * (y % Math.pow(2, zsteps)) || 0;
        var srcW = tile.width / Math.pow(2, zsteps) || 0;
        var srcH = tile.height / Math.pow(2, zsteps) || 0;

        ctx.drawImage(image, srcX, srcY, srcW, srcH, 0, 0, tile.width, tile.height);
      }

      var I = ctx.getImageData(0, 0, tile.width, tile.height);

      if (typeof decodeFunction === 'function') {
        decodeFunction(I.data, tile.width, tile.height, z, decodeParams);
      }

      ctx.putImageData(I, 0, 0);
    },
    reDraw: function reDraw(options) {
      var _this3 = this;

      this.options.params = options.params;
      this.options.sqlParams = options.sqlParams;
      this.options.decodeParams = options.decodeParams;

      var params = options.params,
          sqlParams = options.sqlParams;


      Object.keys(this.tiles).map(function (k) {
        var _tiles$k = _this3.tiles[k],
            x = _tiles$k.x,
            y = _tiles$k.y,
            z = _tiles$k.z;

        var id = replace(params.url, _extends({ x: x, y: y, z: z }, params, { sqlParams: sqlParams }));

        return _this3.drawCanvas(id);
      });
    }
  });

  var fetchData = function fetchData(layerModel) {
    var layerConfig = layerModel.layerConfig,
        params = layerModel.params,
        sqlParams = layerModel.sqlParams,
        layerRequest = layerModel.layerRequest;


    var layerConfigParsed = layerConfig.parse === false ? layerConfig : JSON.parse(replace(JSON.stringify(layerConfig), params, sqlParams));

    var _ref = layerConfigParsed || {},
        body = _ref.body;

    var url = body.url;


    if (layerRequest) {
      layerRequest.cancel('Operation canceled by the user.');
    }

    var layerRequestSource = axios.CancelToken.source();
    layerModel.set('layerRequest', layerRequestSource);

    var newLayerRequest = get$1(url, { cancelToken: layerRequestSource.token }).then(function (res) {
      if (res.status > 400) {
        console.error(res);
        return false;
      }

      return res.data;
    });

    return newLayerRequest;
  };

  function sortKD(ids, coords, nodeSize, left, right, depth) {
      if (right - left <= nodeSize) return;

      var m = Math.floor((left + right) / 2);

      select(ids, coords, m, left, right, depth % 2);

      sortKD(ids, coords, nodeSize, left, m - 1, depth + 1);
      sortKD(ids, coords, nodeSize, m + 1, right, depth + 1);
  }

  function select(ids, coords, k, left, right, inc) {

      while (right > left) {
          if (right - left > 600) {
              var n = right - left + 1;
              var m = k - left + 1;
              var z = Math.log(n);
              var s = 0.5 * Math.exp(2 * z / 3);
              var sd = 0.5 * Math.sqrt(z * s * (n - s) / n) * (m - n / 2 < 0 ? -1 : 1);
              var newLeft = Math.max(left, Math.floor(k - m * s / n + sd));
              var newRight = Math.min(right, Math.floor(k + (n - m) * s / n + sd));
              select(ids, coords, k, newLeft, newRight, inc);
          }

          var t = coords[2 * k + inc];
          var i = left;
          var j = right;

          swapItem(ids, coords, left, k);
          if (coords[2 * right + inc] > t) swapItem(ids, coords, left, right);

          while (i < j) {
              swapItem(ids, coords, i, j);
              i++;
              j--;
              while (coords[2 * i + inc] < t) {
                  i++;
              }while (coords[2 * j + inc] > t) {
                  j--;
              }
          }

          if (coords[2 * left + inc] === t) swapItem(ids, coords, left, j);else {
              j++;
              swapItem(ids, coords, j, right);
          }

          if (j <= k) left = j + 1;
          if (k <= j) right = j - 1;
      }
  }

  function swapItem(ids, coords, i, j) {
      swap(ids, i, j);
      swap(coords, 2 * i, 2 * j);
      swap(coords, 2 * i + 1, 2 * j + 1);
  }

  function swap(arr, i, j) {
      var tmp = arr[i];
      arr[i] = arr[j];
      arr[j] = tmp;
  }

  function range(ids, coords, minX, minY, maxX, maxY, nodeSize) {
      var stack = [0, ids.length - 1, 0];
      var result = [];
      var x, y;

      while (stack.length) {
          var axis = stack.pop();
          var right = stack.pop();
          var left = stack.pop();

          if (right - left <= nodeSize) {
              for (var i = left; i <= right; i++) {
                  x = coords[2 * i];
                  y = coords[2 * i + 1];
                  if (x >= minX && x <= maxX && y >= minY && y <= maxY) result.push(ids[i]);
              }
              continue;
          }

          var m = Math.floor((left + right) / 2);

          x = coords[2 * m];
          y = coords[2 * m + 1];

          if (x >= minX && x <= maxX && y >= minY && y <= maxY) result.push(ids[m]);

          var nextAxis = (axis + 1) % 2;

          if (axis === 0 ? minX <= x : minY <= y) {
              stack.push(left);
              stack.push(m - 1);
              stack.push(nextAxis);
          }
          if (axis === 0 ? maxX >= x : maxY >= y) {
              stack.push(m + 1);
              stack.push(right);
              stack.push(nextAxis);
          }
      }

      return result;
  }

  function within(ids, coords, qx, qy, r, nodeSize) {
      var stack = [0, ids.length - 1, 0];
      var result = [];
      var r2 = r * r;

      while (stack.length) {
          var axis = stack.pop();
          var right = stack.pop();
          var left = stack.pop();

          if (right - left <= nodeSize) {
              for (var i = left; i <= right; i++) {
                  if (sqDist(coords[2 * i], coords[2 * i + 1], qx, qy) <= r2) result.push(ids[i]);
              }
              continue;
          }

          var m = Math.floor((left + right) / 2);

          var x = coords[2 * m];
          var y = coords[2 * m + 1];

          if (sqDist(x, y, qx, qy) <= r2) result.push(ids[m]);

          var nextAxis = (axis + 1) % 2;

          if (axis === 0 ? qx - r <= x : qy - r <= y) {
              stack.push(left);
              stack.push(m - 1);
              stack.push(nextAxis);
          }
          if (axis === 0 ? qx + r >= x : qy + r >= y) {
              stack.push(m + 1);
              stack.push(right);
              stack.push(nextAxis);
          }
      }

      return result;
  }

  function sqDist(ax, ay, bx, by) {
      var dx = ax - bx;
      var dy = ay - by;
      return dx * dx + dy * dy;
  }

  function kdbush(points, getX, getY, nodeSize, ArrayType) {
      return new KDBush(points, getX, getY, nodeSize, ArrayType);
  }

  function KDBush(points, getX, getY, nodeSize, ArrayType) {
      getX = getX || defaultGetX;
      getY = getY || defaultGetY;
      ArrayType = ArrayType || Array;

      this.nodeSize = nodeSize || 64;
      this.points = points;

      this.ids = new ArrayType(points.length);
      this.coords = new ArrayType(points.length * 2);

      for (var i = 0; i < points.length; i++) {
          this.ids[i] = i;
          this.coords[2 * i] = getX(points[i]);
          this.coords[2 * i + 1] = getY(points[i]);
      }

      sortKD(this.ids, this.coords, this.nodeSize, 0, this.ids.length - 1, 0);
  }

  KDBush.prototype = {
      range: function range$$1(minX, minY, maxX, maxY) {
          return range(this.ids, this.coords, minX, minY, maxX, maxY, this.nodeSize);
      },

      within: function within$$1(x, y, r) {
          return within(this.ids, this.coords, x, y, r, this.nodeSize);
      }
  };

  function defaultGetX(p) {
      return p[0];
  }
  function defaultGetY(p) {
      return p[1];
  }

  function supercluster(options) {
      return new SuperCluster(options);
  }

  function SuperCluster(options) {
      this.options = extend(Object.create(this.options), options);
      this.trees = new Array(this.options.maxZoom + 1);
  }

  SuperCluster.prototype = {
      options: {
          minZoom: 0, // min zoom to generate clusters on
          maxZoom: 16, // max zoom level to cluster the points on
          radius: 40, // cluster radius in pixels
          extent: 512, // tile extent (radius is calculated relative to it)
          nodeSize: 64, // size of the KD-tree leaf node, affects performance
          log: false, // whether to log timing info

          // a reduce function for calculating custom cluster properties
          reduce: null, // function (accumulated, props) { accumulated.sum += props.sum; }

          // initial properties of a cluster (before running the reducer)
          initial: function initial() {
              return {};
          }, // function () { return {sum: 0}; },

          // properties to use for individual points when running the reducer
          map: function map(props) {
              return props;
          } // function (props) { return {sum: props.my_value}; },
      },

      load: function load(points) {
          var log = this.options.log;

          if (log) console.time('total time');

          var timerId = 'prepare ' + points.length + ' points';
          if (log) console.time(timerId);

          this.points = points;

          // generate a cluster object for each point and index input points into a KD-tree
          var clusters = [];
          for (var i = 0; i < points.length; i++) {
              if (!points[i].geometry) {
                  continue;
              }
              clusters.push(createPointCluster(points[i], i));
          }
          this.trees[this.options.maxZoom + 1] = kdbush(clusters, getX, getY, this.options.nodeSize, Float32Array);

          if (log) console.timeEnd(timerId);

          // cluster points on max zoom, then cluster the results on previous zoom, etc.;
          // results in a cluster hierarchy across zoom levels
          for (var z = this.options.maxZoom; z >= this.options.minZoom; z--) {
              var now = +Date.now();

              // create a new set of clusters for the zoom and index them with a KD-tree
              clusters = this._cluster(clusters, z);
              this.trees[z] = kdbush(clusters, getX, getY, this.options.nodeSize, Float32Array);

              if (log) console.log('z%d: %d clusters in %dms', z, clusters.length, +Date.now() - now);
          }

          if (log) console.timeEnd('total time');

          return this;
      },

      getClusters: function getClusters(bbox, zoom) {
          var minLng = ((bbox[0] + 180) % 360 + 360) % 360 - 180;
          var minLat = Math.max(-90, Math.min(90, bbox[1]));
          var maxLng = bbox[2] === 180 ? 180 : ((bbox[2] + 180) % 360 + 360) % 360 - 180;
          var maxLat = Math.max(-90, Math.min(90, bbox[3]));

          if (bbox[2] - bbox[0] >= 360) {
              minLng = -180;
              maxLng = 180;
          } else if (minLng > maxLng) {
              var easternHem = this.getClusters([minLng, minLat, 180, maxLat], zoom);
              var westernHem = this.getClusters([-180, minLat, maxLng, maxLat], zoom);
              return easternHem.concat(westernHem);
          }

          var tree = this.trees[this._limitZoom(zoom)];
          var ids = tree.range(lngX(minLng), latY(maxLat), lngX(maxLng), latY(minLat));
          var clusters = [];
          for (var i = 0; i < ids.length; i++) {
              var c = tree.points[ids[i]];
              clusters.push(c.numPoints ? getClusterJSON(c) : this.points[c.index]);
          }
          return clusters;
      },

      getChildren: function getChildren(clusterId) {
          var originId = clusterId >> 5;
          var originZoom = clusterId % 32;
          var errorMsg = 'No cluster with the specified id.';

          var index = this.trees[originZoom];
          if (!index) throw new Error(errorMsg);

          var origin = index.points[originId];
          if (!origin) throw new Error(errorMsg);

          var r = this.options.radius / (this.options.extent * Math.pow(2, originZoom - 1));
          var ids = index.within(origin.x, origin.y, r);
          var children = [];
          for (var i = 0; i < ids.length; i++) {
              var c = index.points[ids[i]];
              if (c.parentId === clusterId) {
                  children.push(c.numPoints ? getClusterJSON(c) : this.points[c.index]);
              }
          }

          if (children.length === 0) throw new Error(errorMsg);

          return children;
      },

      getLeaves: function getLeaves(clusterId, limit, offset) {
          limit = limit || 10;
          offset = offset || 0;

          var leaves = [];
          this._appendLeaves(leaves, clusterId, limit, offset, 0);

          return leaves;
      },

      getTile: function getTile(z, x, y) {
          var tree = this.trees[this._limitZoom(z)];
          var z2 = Math.pow(2, z);
          var extent = this.options.extent;
          var r = this.options.radius;
          var p = r / extent;
          var top = (y - p) / z2;
          var bottom = (y + 1 + p) / z2;

          var tile = {
              features: []
          };

          this._addTileFeatures(tree.range((x - p) / z2, top, (x + 1 + p) / z2, bottom), tree.points, x, y, z2, tile);

          if (x === 0) {
              this._addTileFeatures(tree.range(1 - p / z2, top, 1, bottom), tree.points, z2, y, z2, tile);
          }
          if (x === z2 - 1) {
              this._addTileFeatures(tree.range(0, top, p / z2, bottom), tree.points, -1, y, z2, tile);
          }

          return tile.features.length ? tile : null;
      },

      getClusterExpansionZoom: function getClusterExpansionZoom(clusterId) {
          var clusterZoom = clusterId % 32 - 1;
          while (clusterZoom < this.options.maxZoom) {
              var children = this.getChildren(clusterId);
              clusterZoom++;
              if (children.length !== 1) break;
              clusterId = children[0].properties.cluster_id;
          }
          return clusterZoom;
      },

      _appendLeaves: function _appendLeaves(result, clusterId, limit, offset, skipped) {
          var children = this.getChildren(clusterId);

          for (var i = 0; i < children.length; i++) {
              var props = children[i].properties;

              if (props && props.cluster) {
                  if (skipped + props.point_count <= offset) {
                      // skip the whole cluster
                      skipped += props.point_count;
                  } else {
                      // enter the cluster
                      skipped = this._appendLeaves(result, props.cluster_id, limit, offset, skipped);
                      // exit the cluster
                  }
              } else if (skipped < offset) {
                  // skip a single point
                  skipped++;
              } else {
                  // add a single point
                  result.push(children[i]);
              }
              if (result.length === limit) break;
          }

          return skipped;
      },

      _addTileFeatures: function _addTileFeatures(ids, points, x, y, z2, tile) {
          for (var i = 0; i < ids.length; i++) {
              var c = points[ids[i]];
              var f = {
                  type: 1,
                  geometry: [[Math.round(this.options.extent * (c.x * z2 - x)), Math.round(this.options.extent * (c.y * z2 - y))]],
                  tags: c.numPoints ? getClusterProperties(c) : this.points[c.index].properties
              };
              var id = c.numPoints ? c.id : this.points[c.index].id;
              if (id !== undefined) {
                  f.id = id;
              }
              tile.features.push(f);
          }
      },

      _limitZoom: function _limitZoom(z) {
          return Math.max(this.options.minZoom, Math.min(z, this.options.maxZoom + 1));
      },

      _cluster: function _cluster(points, zoom) {
          var clusters = [];
          var r = this.options.radius / (this.options.extent * Math.pow(2, zoom));

          // loop through each point
          for (var i = 0; i < points.length; i++) {
              var p = points[i];
              // if we've already visited the point at this zoom level, skip it
              if (p.zoom <= zoom) continue;
              p.zoom = zoom;

              // find all nearby points
              var tree = this.trees[zoom + 1];
              var neighborIds = tree.within(p.x, p.y, r);

              var numPoints = p.numPoints || 1;
              var wx = p.x * numPoints;
              var wy = p.y * numPoints;

              var clusterProperties = null;

              if (this.options.reduce) {
                  clusterProperties = this.options.initial();
                  this._accumulate(clusterProperties, p);
              }

              // encode both zoom and point index on which the cluster originated
              var id = (i << 5) + (zoom + 1);

              for (var j = 0; j < neighborIds.length; j++) {
                  var b = tree.points[neighborIds[j]];
                  // filter out neighbors that are already processed
                  if (b.zoom <= zoom) continue;
                  b.zoom = zoom; // save the zoom (so it doesn't get processed twice)

                  var numPoints2 = b.numPoints || 1;
                  wx += b.x * numPoints2; // accumulate coordinates for calculating weighted center
                  wy += b.y * numPoints2;

                  numPoints += numPoints2;
                  b.parentId = id;

                  if (this.options.reduce) {
                      this._accumulate(clusterProperties, b);
                  }
              }

              if (numPoints === 1) {
                  clusters.push(p);
              } else {
                  p.parentId = id;
                  clusters.push(createCluster(wx / numPoints, wy / numPoints, id, numPoints, clusterProperties));
              }
          }

          return clusters;
      },

      _accumulate: function _accumulate(clusterProperties, point) {
          var properties = point.numPoints ? point.properties : this.options.map(this.points[point.index].properties);

          this.options.reduce(clusterProperties, properties);
      }
  };

  function createCluster(x, y, id, numPoints, properties) {
      return {
          x: x, // weighted cluster center
          y: y,
          zoom: Infinity, // the last zoom the cluster was processed at
          id: id, // encodes index of the first child of the cluster and its zoom level
          parentId: -1, // parent cluster id
          numPoints: numPoints,
          properties: properties
      };
  }

  function createPointCluster(p, id) {
      var coords = p.geometry.coordinates;
      return {
          x: lngX(coords[0]), // projected point coordinates
          y: latY(coords[1]),
          zoom: Infinity, // the last zoom the point was processed at
          index: id, // index of the source feature in the original input array,
          parentId: -1 // parent cluster id
      };
  }

  function getClusterJSON(cluster) {
      return {
          type: 'Feature',
          id: cluster.id,
          properties: getClusterProperties(cluster),
          geometry: {
              type: 'Point',
              coordinates: [xLng(cluster.x), yLat(cluster.y)]
          }
      };
  }

  function getClusterProperties(cluster) {
      var count = cluster.numPoints;
      var abbrev = count >= 10000 ? Math.round(count / 1000) + 'k' : count >= 1000 ? Math.round(count / 100) / 10 + 'k' : count;
      return extend(extend({}, cluster.properties), {
          cluster: true,
          cluster_id: cluster.id,
          point_count: count,
          point_count_abbreviated: abbrev
      });
  }

  // longitude/latitude to spherical mercator in [0..1] range
  function lngX(lng) {
      return lng / 360 + 0.5;
  }
  function latY(lat) {
      var sin = Math.sin(lat * Math.PI / 180),
          y = 0.5 - 0.25 * Math.log((1 + sin) / (1 - sin)) / Math.PI;
      return y < 0 ? 0 : y > 1 ? 1 : y;
  }

  // spherical mercator to longitude/latitude
  function xLng(x) {
      return (x - 0.5) * 360;
  }
  function yLat(y) {
      var y2 = (180 - y * 360) * Math.PI / 180;
      return 360 * Math.atan(Math.exp(y2)) / Math.PI - 90;
  }

  function extend(dest, src) {
      for (var id in src) {
          dest[id] = src[id];
      }return dest;
  }

  function getX(p) {
      return p.x;
  }
  function getY(p) {
      return p.y;
  }

  /* eslint no-underscore-dangle: 0 */

  var _ref$2 = typeof window !== 'undefined' ? window : {},
      L$2 = _ref$2.L;

  var defaultSizes = {
    50: 25,
    100: 30,
    1000: 40
  };

  var ClusterLayer = L$2 && L$2.GeoJSON.extend({
    initialize: function initialize(layerModel) {
      var _this = this;

      var self = this;
      L$2.GeoJSON.prototype.initialize.call(this, []);
      var layerConfig = layerModel.layerConfig,
          events = layerModel.events,
          decodeClusters = layerModel.decodeClusters;

      if (!decodeClusters) {
        console.warn('You must provide a decodeClusters function');
        return;
      }

      var _ref2 = layerModel.layerConfig || {},
          html = _ref2.html,
          _ref2$sizes = _ref2.sizes,
          sizes = _ref2$sizes === undefined ? defaultSizes : _ref2$sizes,
          clusterIcon = _ref2.clusterIcon,
          icon = _ref2.icon;

      L$2.Util.setOptions(this, {
        // converts feature to icon
        pointToLayer: function pointToLayer(feature, latlng) {
          var isCluster = feature.properties && feature.properties.cluster;

          // if cluster return point icon
          if (!isCluster) {
            // see documentation for icon config https://leafletjs.com/reference-1.3.4.html#icon
            return L$2.marker(latlng, { icon: L$2.icon(_extends({ iconSize: [35, 35] }, icon)) });
          }

          var count = feature.properties.point_count;
          var iconSize = null;

          if (typeof sizes === 'function') {
            iconSize = function iconSize() {
              return sizes(count);
            };
          } else {
            var sizeKey = Object.keys(sizes).find(function (o) {
              return count <= parseInt(o, 10);
            });
            var size = sizes[sizeKey];
            iconSize = L$2.point(size, size);
          }

          // see documentation for icon config https://leafletjs.com/reference-1.3.4.html#divicon
          return L$2.marker(latlng, {
            icon: L$2.divIcon(_extends({
              iconSize: iconSize,
              html: html && typeof html === 'function' ? html(feature) : '<div style="width: 100%; height: 100%; display: flex; align-items: center; justify-content: center; ' + (clusterIcon.color ? 'background-color: ' + clusterIcon.color + ';' : '') + '">' + feature.properties.point_count_abbreviated + '</div>'
            }, clusterIcon))
          });
        },


        // parses each feature before adding to the map
        onEachFeature: function onEachFeature(feature, layer) {
          if (feature.properties && feature.properties.cluster) {
            layer.on({
              click: function click() {
                return self.setMapView(feature);
              }
            });
          } else if (events) {
            layer.on(Object.keys(events).reduce(function (obj, event) {
              return _extends({}, obj, defineProperty({}, event, function (e) {
                return events[event](_extends({}, e, { data: feature.properties }));
              }));
            }, {}));
          }
        }
      });

      // https://github.com/mapbox/supercluster options available here

      var _ref3 = layerConfig || {},
          clusterConfig = _ref3.clusterConfig;

      this.supercluster = supercluster(_extends({
        radius: 80,
        maxZoom: 16
      }, clusterConfig));

      fetchData(layerModel).then(function (response) {
        var features = decodeClusters(response);
        _this.supercluster.load(features);
        _this.update();
      });
    },
    setMapView: function setMapView(feature) {
      var center = feature.geometry.coordinates;
      var zoom = this.supercluster.getClusterExpansionZoom(feature.properties.cluster_id);
      this._map.setView(center.reverse(), zoom);
    },
    onAdd: function onAdd(map) {
      L$2.GeoJSON.prototype.onAdd.call(this, map);
      map.on('moveend zoomend', this.onMove, this);
    },
    onRemove: function onRemove(map) {
      map.off('moveend zoomend', this.onMove, this);
      this.clear();
    },
    onMove: function onMove() {
      this.clear();
      this.update();
    },
    update: function update() {
      var zoom = this._map.getZoom();
      var bounds = this._map.getBounds();
      var clusterBounds = [bounds._southWest.lng, bounds._southWest.lat, bounds._northEast.lng, bounds._northEast.lat];
      var clusters = this.supercluster.getClusters(clusterBounds, zoom);
      this.addData(clusters);
    },
    clear: function clear() {
      L$2.GeoJSON.prototype.clearLayers.call(this, []);
    }
  });

  var _ref$3 = typeof window !== 'undefined' ? window : {},
      L$3 = _ref$3.L;

  var UTFGridLayer = L$3 && L$3.GridLayer.extend({
    tiles: {},
    cache: {},
    mouseOn: null,
    createTile: function createTile(_ref2) {
      var z = _ref2.z;

      // Delete all tiles from others zooms;
      var tilesKeys = Object.keys(this.tiles);
      for (var i = 0; i < tilesKeys.length; i++) {
        if (this.tiles[tilesKeys[i]].z !== z) {
          delete this.tiles[tilesKeys[i]];
        }
      }

      var tile = L$3.DomUtil.create('div', 'leaflet-tile');
      var size = this.getTileSize();

      // setup tile width and height according to the options
      tile.width = size.x;
      tile.height = size.y;

      return tile;
    },
    onAdd: function onAdd(map) {
      // Very important line
      L$3.GridLayer.prototype.onAdd.call(this, map);

      this.map = map;

      var zoom = Math.round(this.map.getZoom());

      if (zoom > this.options.maxZoom || zoom < this.options.minZoom) {
        return;
      }

      map.on('click', this.click, this);
      map.on('mousemove', this.move, this);
    },
    onRemove: function onRemove() {
      var map = this.map;

      map.off('click', this.click, this);
      map.off('mousemove', this.move, this);
    },
    click: function click(e) {
      this.fire('click', this.objectForEvent(e));
    },
    move: function move(e) {
      var on = this.objectForEvent(e);

      if (on.data !== this.mouseOn) {
        if (this.mouseOn) {
          this.fire('mouseout', { latlng: e.latlng, data: this.mouseOn });
        }
        if (on.data) {
          this.fire('mouseover', on);
        }

        this.mouseOn = on.data;
      } else if (on.data) {
        this.fire('mousemove', on);
      }
    },
    objectForEvent: function objectForEvent(e) {
      return L$3.extend({ latlng: e.latlng, data: null }, e);
    }
  });

  var _ref$4 = typeof window !== 'undefined' ? window : {},
      L$4 = _ref$4.L;

  var eval2 = eval;

  var LeafletLayer = function LeafletLayer(layerModel) {
    if (!L$4) throw new Error('Leaflet must be defined.');

    var layerConfig = layerModel.layerConfig,
        params = layerModel.params,
        sqlParams = layerModel.sqlParams,
        decodeParams = layerModel.decodeParams,
        interactivity = layerModel.interactivity;

    var layer = void 0;

    var layerConfigParsed = layerConfig.parse === false ? layerConfig : JSON.parse(replace(JSON.stringify(layerConfig), params, sqlParams));

    // Transforming data layer
    if (layerConfigParsed.body.crs && L$4.CRS[layerConfigParsed.body.crs]) {
      layerConfigParsed.body.crs = L$4.CRS[layerConfigParsed.body.crs.replace(':', '')];
      layerConfigParsed.body.pane = 'tilePane';
    }

    switch (layerConfigParsed.type) {
      case 'wms':
        layer = L$4.tileLayer.wms(layerConfigParsed.url || layerConfigParsed.body.url, layerConfigParsed.body);
        break;
      case 'tileLayer':
        if (JSON.stringify(layerConfigParsed.body).indexOf('style: "function') >= 0) {
          layerConfigParsed.body.style = eval2('(' + layerConfigParsed.body.style + ')');
        }
        if (decodeParams) {
          layer = new CanvasLayer(_extends({}, layerModel));
        } else {
          layer = L$4.tileLayer(layerConfigParsed.url || layerConfigParsed.body.url, layerConfigParsed.body);
        }

        // Add interactivity
        if (interactivity) {
          var interactiveLayer = new UTFGridLayer();

          var LayerGroup = L$4.LayerGroup.extend({
            group: true,
            setOpacity: function setOpacity(opacity) {
              layerModel.mapLayer.getLayers().forEach(function (l) {
                l.setOpacity(opacity);
              });
            }
          });

          layer = new LayerGroup([layer, interactiveLayer]);
        }

        break;
      case 'cluster':
        if (JSON.stringify(layerConfigParsed.body).indexOf('style: "function') >= 0) {
          layerConfigParsed.body.style = eval2('(' + layerConfigParsed.body.style + ')');
        }
        layer = new ClusterLayer(layerModel);
        break;
      default:
        layer = L$4[layerConfigParsed.type](layerConfigParsed.body, layerConfigParsed.options || {});
        break;
    }

    return new Promise(function (resolve, reject) {
      if (layer) {
        resolve(layer);
      } else {
        reject(new Error('"type" specified in layer spec doesn`t exist'));
      }
    });
  };

  /* eslint no-underscore-dangle: ["error", { "allow": ["_currentImage", "_image"] }] */

  var _ref$5 = typeof window !== 'undefined' ? window : {},
      L$5 = _ref$5.L;

  var eval2$1 = eval;

  var EsriLayer = function EsriLayer(layerModel) {
    if (!L$5) throw new Error('Leaflet must be defined.');
    if (!L$5.esri) {
      throw new Error('To support this layer you should add esri library for Leaflet.');
    }

    // Preparing layerConfig
    var layerConfig = layerModel.layerConfig,
        interactivity = layerModel.interactivity,
        params = layerModel.params,
        sqlParams = layerModel.sqlParams;

    var layerConfigParsed = layerConfig.parse === false ? layerConfig : JSON.parse(replace(JSON.stringify(layerConfig), params, sqlParams));

    var bodyStringified = JSON.stringify(layerConfigParsed.body || {}).replace(/"mosaic-rule":/g, '"mosaicRule":').replace(/"mosaic_rule":/g, '"mosaicRule":').replace(/"use-cors":/g, '"useCors":').replace(/"use_cors":/g, '"useCors":');

    // If type is a method of leaflet, returns LeafletLayer
    if (L$5[layerConfigParsed.type]) return new LeafletLayer(_extends({}, layerModel));

    return new Promise(function (resolve, reject) {
      if (!L$5.esri[layerConfigParsed.type]) {
        return reject(new Error('"type" specified in layer spec doesn`t exist'));
      }

      var layerOptions = JSON.parse(bodyStringified);
      layerOptions.pane = 'tilePane';
      layerOptions.useCors = true;
      // forcing cors
      if (layerOptions.style && layerOptions.style.indexOf('function') >= 0) {
        layerOptions.style = eval2$1('(' + layerOptions.style + ')');
      }

      var layer = void 0;

      layer = L$5.esri[layerConfigParsed.type](layerOptions);

      if (layer) {
        // Little hack to set zIndex at the beginning
        layer.on('load', function () {
          layer.setZIndex(layerModel.zIndex);
        });

        layer.on('requesterror', function (err) {
          return console.error(err);
        });
      } else {
        return reject();
      }

      if (!layer.setZIndex) {
        layer.setZIndex = function (zIndex) {
          if (layer._currentImage) {
            layer._currentImage._image.style.zIndex = zIndex;
          }
        };
      }

      // Add interactivity
      if (interactivity) {
        var interactiveLayer = new UTFGridLayer();

        var LayerGroup = L$5.LayerGroup.extend({
          group: true,
          setOpacity: function setOpacity(opacity) {
            layerModel.mapLayer.getLayers().forEach(function (l) {
              l.setOpacity(opacity);
            });
          }
        });

        layer = new LayerGroup([layer, interactiveLayer]);
      }

      return resolve(layer);
    });
  };

  var _ref$6 = typeof window !== 'undefined' ? window : {},
      L$6 = _ref$6.L;

  var GEELayer = function GEELayer(layerModel) {
    if (!L$6) throw new Error('Leaflet must be defined.');

    var id = layerModel.id,
        layerConfig = layerModel.layerConfig,
        interactivity = layerModel.interactivity,
        params = layerModel.params,
        sqlParams = layerModel.sqlParams,
        decodeParams = layerModel.decodeParams;

    var tileUrl = 'https://api.resourcewatch.org/v1/layer/' + id + '/tile/gee/{z}/{x}/{y}';
    var layerConfigParsed = layerConfig.parse === false ? layerConfig : JSON.parse(replace(JSON.stringify(layerConfig), params, sqlParams));
    var layer = void 0;

    switch (layerConfigParsed.type) {
      case 'tileLayer':
        if (decodeParams) {
          layer = new CanvasLayer(_extends({}, layerModel));
        } else {
          layer = L$6.tileLayer(tileUrl, layerConfigParsed.body);
        }
        break;
      default:
        layer = L$6.tileLayer(tileUrl, layerConfigParsed.body);
        break;
    }

    // Add interactivity
    if (interactivity) {
      var interactiveLayer = new UTFGridLayer();

      var LayerGroup = L$6.LayerGroup.extend({
        group: true,
        setOpacity: function setOpacity(opacity) {
          layerModel.mapLayer.getLayers().forEach(function (l) {
            l.setOpacity(opacity);
          });
        }
      });

      layer = new LayerGroup([layer, interactiveLayer]);
    }

    return new Promise(function (resolve, reject) {
      if (layer) {
        resolve(layer);
      } else {
        reject(new Error('"type" specified in layer spec doesn`t exist'));
      }
    });
  };

  var _ref$7 = typeof window !== 'undefined' ? window : {},
      L$7 = _ref$7.L;

  var maxBounds = L$7 && new L$7.LatLngBounds(new L$7.LatLng(49.496674527470455, -66.357421875), new L$7.LatLng(24.607069137709683, -131.66015625));

  var LOCALayer = function LOCALayer(layerModel) {
    var id = layerModel.id,
        layerConfig = layerModel.layerConfig,
        interactivity = layerModel.interactivity;
    var period = layerConfig.period;

    var year = (period || {}).value || '1971';
    var dateString = new Date(year).toISOString();
    var tileUrl = 'https://api.resourcewatch.org/v1/layer/' + id + '/tile/loca/{z}/{x}/{y}?year=' + dateString;

    var layer = L$7.tileLayer(tileUrl, _extends({}, layerConfig.body, {
      minNativeZoom: 4,
      bounds: maxBounds
    }));

    // Add interactivity
    if (interactivity) {
      var interactiveLayer = new UTFGridLayer();

      var LayerGroup = L$7.LayerGroup.extend({
        group: true,
        setOpacity: function setOpacity(opacity) {
          layerModel.mapLayer.getLayers().forEach(function (l) {
            l.setOpacity(opacity);
          });
        }
      });

      layer = new LayerGroup([layer, interactiveLayer]);
    }

    return new Promise(function (resolve) {
      resolve(layer);
    });
  };

  var _ref$8 = typeof window !== 'undefined' ? window : {},
      L$8 = _ref$8.L;

  var NEXGDDPLayer = function NEXGDDPLayer(layerModel) {
    var id = layerModel.id,
        layerConfig = layerModel.layerConfig,
        interactivity = layerModel.interactivity;
    var period = layerConfig.period;

    var year = (period || {}).value || '1971-01-01';
    var dateString = new Date(year).toISOString();
    var tileUrl = 'https://api.resourcewatch.org/v1/layer/' + id + '/tile/nexgddp/{z}/{x}/{y}?year=' + dateString;

    var layer = L$8.tileLayer(tileUrl, layerConfig.body);

    // Add interactivity
    if (interactivity) {
      var interactiveLayer = new UTFGridLayer();

      var LayerGroup = L$8.LayerGroup.extend({
        group: true,
        setOpacity: function setOpacity(opacity) {
          layerModel.mapLayer.getLayers().forEach(function (l) {
            l.setOpacity(opacity);
          });
        }
      });

      layer = new LayerGroup([layer, interactiveLayer]);
    }

    return new Promise(function (resolve) {
      resolve(layer);
    });
  };

  var PluginLeaflet = function () {
    function PluginLeaflet(map) {
      var _this = this;

      classCallCheck(this, PluginLeaflet);
      this.events = {};
      this.methods = {
        // CARTO
        cartodb: CartoLayer,
        carto: CartoLayer,
        // ESRI
        arcgis: EsriLayer,
        featureservice: EsriLayer,
        mapservice: EsriLayer,
        tileservice: EsriLayer,
        esrifeatureservice: EsriLayer,
        esrimapservice: EsriLayer,
        esritileservice: EsriLayer,
        // GEE && LOCA && NEXGDDP
        gee: GEELayer,
        loca: LOCALayer,
        nexgddp: NEXGDDPLayer,
        // LEAFLET
        leaflet: LeafletLayer,
        wms: LeafletLayer
      };

      this.setEvents = function (layerModel) {
        var mapLayer = layerModel.mapLayer,
            events = layerModel.events;

        if (layerModel.layerConfig.type !== 'cluster') {
          // Remove current events
          if (_this.events[layerModel.id]) {
            Object.keys(_this.events[layerModel.id]).forEach(function (k) {
              if (mapLayer.group) {
                mapLayer.eachLayer(function (l) {
                  l.off(k);
                });
              } else {
                mapLayer.off(k);
              }
            });
          }

          // Add new events
          Object.keys(events).forEach(function (k) {
            if (mapLayer.group) {
              mapLayer.eachLayer(function (l) {
                l.on(k, events[k]);
              });
            } else {
              mapLayer.on(k, events[k]);
            }
          });
          // Set this.events equal to current ones
          _this.events[layerModel.id] = events;
        }

        return _this;
      };

      this.map = map;
    }

    createClass(PluginLeaflet, [{
      key: 'add',


      /**
       * Add a layer
       * @param {Object} layerModel
       */
      value: function add(layerModel) {
        var mapLayer = layerModel.mapLayer;


        this.map.addLayer(mapLayer);
      }

      /**
       * Remove a layer
       * @param {Object} layerModel
       */

    }, {
      key: 'remove',
      value: function remove(layerModel) {
        var mapLayer = layerModel.mapLayer,
            events = layerModel.events;


        if (events && mapLayer) {
          Object.keys(events).forEach(function (k) {
            if (mapLayer.group) {
              mapLayer.eachLayer(function (l) {
                l.off(k);
              });
            } else {
              mapLayer.off(k);
            }
          });
        }

        if (mapLayer) {
          this.map.removeLayer(mapLayer);
        }
      }

      /**
       * Get provider method
       * @param {String} provider
       */

    }, {
      key: 'getLayerByProvider',
      value: function getLayerByProvider(provider) {
        return this.methods[provider];
      }

      /**
       * A namespace to set z-index
       * @param {Object} layerModel
       * @param {Number} zIndex
       */

    }, {
      key: 'setZIndex',
      value: function setZIndex(layerModel, zIndex) {
        var mapLayer = layerModel.mapLayer;


        mapLayer.setZIndex(zIndex);

        return this;
      }

      /**
       * A namespace to set opacity
       * @param {Object} layerModel
       * @param {Number} opacity
       */

    }, {
      key: 'setOpacity',
      value: function setOpacity(layerModel, opacity) {
        var mapLayer = layerModel.mapLayer;


        if (typeof mapLayer.setOpacity === 'function') {
          mapLayer.setOpacity(opacity);
        }

        if (typeof mapLayer.setStyle === 'function') {
          mapLayer.setStyle({ opacity: opacity });
        }

        return this;
      }

      /**
       * A namespace to hide or show a selected layer
       * @param {Object} layerModel
       * @param {Boolean} visibility
       */

    }, {
      key: 'setVisibility',
      value: function setVisibility(layerModel, visibility) {
        var opacity = layerModel.opacity;


        this.setOpacity(layerModel, !visibility ? 0 : opacity);
      }

      /**
       * A namespace to set DOM events
       * @param {Object} layerModel
       */

    }, {
      key: 'setParams',
      value: function setParams(layerModel) {
        this.remove(layerModel);
      }
    }, {
      key: 'setSQLParams',
      value: function setSQLParams(layerModel) {
        this.remove(layerModel);
      }
    }, {
      key: 'setLayerConfig',
      value: function setLayerConfig(layerModel) {
        this.remove(layerModel);
      }
    }, {
      key: 'setDecodeParams',
      value: function setDecodeParams(layerModel) {
        var mapLayer = layerModel.mapLayer,
            params = layerModel.params,
            sqlParams = layerModel.sqlParams,
            decodeParams = layerModel.decodeParams,
            decodeFunction = layerModel.decodeFunction;


        mapLayer.reDraw({ decodeParams: decodeParams, decodeFunction: decodeFunction, params: params, sqlParams: sqlParams });

        return this;
      }
    }]);
    return PluginLeaflet;
  }();

  var handleCallback = function handleCallback(resolve, reject, callback, r) {
    try {
      resolve(callback(r));
    } catch (e) {
      reject(e);
    }
  };

  var CancelablePromise = function () {
    createClass(CancelablePromise, null, [{
      key: "all",
      value: function all(iterable) {
        return new CancelablePromise(function (y, n) {
          Promise.all(iterable).then(y, n);
        });
      }
    }, {
      key: "race",
      value: function race(iterable) {
        return new CancelablePromise(function (y, n) {
          Promise.race(iterable).then(y, n);
        });
      }
    }, {
      key: "reject",
      value: function reject(value) {
        return new CancelablePromise(function (y, n) {
          Promise.reject(value).then(y, n);
        });
      }
    }, {
      key: "resolve",
      value: function resolve(value) {
        return new CancelablePromise(function (y, n) {
          Promise.resolve(value).then(y, n);
        });
      }
    }]);

    function CancelablePromise(executor) {
      classCallCheck(this, CancelablePromise);

      this._promise = new Promise(executor);
      this._canceled = false;
    }

    createClass(CancelablePromise, [{
      key: "then",
      value: function then(success, error) {
        var _this = this;

        var p = new CancelablePromise(function (resolve, reject) {
          _this._promise.then(function (r) {
            if (_this._canceled) {
              p.cancel();
            }
            if (success && !_this._canceled) {
              handleCallback(resolve, reject, success, r);
            } else {
              resolve(r);
            }
          }, function (r) {
            if (_this._canceled) {
              p.cancel();
            }
            if (error && !_this._canceled) {
              handleCallback(resolve, reject, error, r);
            } else {
              reject(r);
            }
          });
        });
        return p;
      }
    }, {
      key: "catch",
      value: function _catch(error) {
        return this.then(undefined, error);
      }
    }, {
      key: "cancel",
      value: function cancel(errorCallback) {
        this._canceled = true;
        if (errorCallback) {
          this._promise.catch(errorCallback);
        }
        return this;
      }
    }]);
    return CancelablePromise;
  }();

  var vs = "\n#define SHADER_NAME bitmap-layer-vertex-shader\n\nattribute vec2 texCoords;\nattribute vec3 positions;\nattribute vec2 positions64xyLow;\n\nvarying vec2 vTexCoord;\n\nvoid main(void) {\n  gl_Position = project_position_to_clipspace(positions, positions64xyLow, vec3(0.0));\n \n  vTexCoord = texCoords;\n \n  picking_setPickingColor(vec3(0., 0., 1.));\n}\n";

  var shaderTemplate = "\n#define SHADER_NAME bitmap-layer-fragment-shader\n\n#ifdef GL_ES\nprecision highp float;\n#endif\n\nuniform sampler2D bitmapTexture;\n\nvarying vec2 vTexCoord;\n\n{decodeParams}\n\nuniform float opacity;\nuniform float zoom;\n\n\nvec4 decodeFunction(vec3 color, float alpha) {\n  {decodeFunction}\n  return vec4(color, alpha * opacity);\n}\n\nvoid main(void) {\n  vec4 bitmapColor = texture2D(bitmapTexture, vTexCoord);\n\n  // clear mask\n  if (bitmapColor == vec4(0., 0., 0., 1.)) {\n    discard;\n  }\n\n  // custom decode\n  gl_FragColor = decodeFunction(bitmapColor.rgb, bitmapColor.a);\n\n  // use highlight color if this fragment belongs to the selected object.\n  gl_FragColor = picking_filterHighlightColor(gl_FragColor);\n\n  // use picking color if rendering to picking FBO.\n  gl_FragColor = picking_filterPickingColor(gl_FragColor);\n}\n";

  var _DEFAULT_TEXTURE_PARA;

  var fp64LowPart = luma_gl.fp64.fp64LowPart;


  var DEFAULT_TEXTURE_PARAMETERS = (_DEFAULT_TEXTURE_PARA = {}, defineProperty(_DEFAULT_TEXTURE_PARA, GL.TEXTURE_MIN_FILTER, GL.NEAREST), defineProperty(_DEFAULT_TEXTURE_PARA, GL.TEXTURE_MAG_FILTER, GL.NEAREST), defineProperty(_DEFAULT_TEXTURE_PARA, GL.TEXTURE_WRAP_S, GL.CLAMP_TO_EDGE), defineProperty(_DEFAULT_TEXTURE_PARA, GL.TEXTURE_WRAP_T, GL.CLAMP_TO_EDGE), _DEFAULT_TEXTURE_PARA);

  var defaultProps = {
    image: null,
    bounds: { type: 'array', value: [1, 0, 0, 1], compare: true },
    fp64: false,

    desaturate: { type: 'number', min: 0, max: 1, value: 0 },
    // More context: because of the blending mode we're using for ground imagery,
    // alpha is not effective when blending the bitmap layers with the base map.
    // Instead we need to manually dim/blend rgb values with a background color.
    transparentColor: { type: 'color', value: [0, 0, 0, 0] },
    tintColor: { type: 'color', value: [255, 255, 255] }
  };

  /*
   * @class
   * @param {object} props
   * @param {number} props.transparentColor - color to interpret transparency to
   * @param {number} props.tintColor - color bias
   */

  var BitmapLayer = function (_Layer) {
    inherits(BitmapLayer, _Layer);

    function BitmapLayer() {
      classCallCheck(this, BitmapLayer);
      return possibleConstructorReturn(this, (BitmapLayer.__proto__ || Object.getPrototypeOf(BitmapLayer)).apply(this, arguments));
    }

    createClass(BitmapLayer, [{
      key: 'getShaders',
      value: function getShaders() {
        var projectModule = this.use64bitProjection() ? 'project64' : 'project32';
        var fs = shaderTemplate.replace('{decodeParams}', Object.keys(this.props.decodeParams).map(function (p) {
          return 'uniform float ' + p + ';';
        }).join(' ')).replace('{decodeFunction}', this.props.decodeFunction || '');

        return { vs: vs, fs: fs, modules: [projectModule, 'picking'] };
      }
    }, {
      key: 'initializeState',
      value: function initializeState() {
        var attributeManager = this.getAttributeManager();

        attributeManager.add({
          positions: {
            size: 3,
            update: this.calculatePositions,
            value: new Float32Array(12)
          },
          positions64xyLow: {
            size: 3,
            update: this.calculatePositions64xyLow,
            value: new Float32Array(12)
          }
        });

        this.setState({ numInstances: 4 }); // 4 corners
      }
    }, {
      key: 'updateState',
      value: function updateState(_ref) {
        var props = _ref.props,
            oldProps = _ref.oldProps;

        // setup model first
        if (props.fp64 !== oldProps.fp64) {
          var gl = this.context.gl;

          if (this.state.model) {
            this.state.model.delete();
          }
          this.setState({ model: this._getModel(gl) });
          this.getAttributeManager().invalidateAll();
        }

        if (props.image !== oldProps.image) {
          this.loadTexture(props.image);
        }

        var attributeManager = this.getAttributeManager();

        if (props.bounds !== oldProps.bounds) {
          this.setState({
            positions: this._getPositionsFromBounds(props.bounds)
          });
          attributeManager.invalidate('positions');
          attributeManager.invalidate('positions64xyLow');
        }
      }
    }, {
      key: 'finalizeState',
      value: function finalizeState() {
        get(BitmapLayer.prototype.__proto__ || Object.getPrototypeOf(BitmapLayer.prototype), 'finalizeState', this).call(this);

        if (this.state.bitmapTexture) {
          this.state.bitmapTexture.delete();
        }
      }
    }, {
      key: '_getPositionsFromBounds',
      value: function _getPositionsFromBounds(bounds) {
        var positions = new Array(12);
        // bounds as [minX, minY, maxX, maxY]
        if (Number.isFinite(bounds[0])) {
          /*
            (minX0, maxY3) ---- (maxX2, maxY3)
                   |                  |
                   |                  |
                   |                  |
            (minX0, minY1) ---- (maxX2, minY1)
          */
          positions[0] = bounds[0];
          positions[1] = bounds[1];
          positions[2] = 0;

          positions[3] = bounds[0];
          positions[4] = bounds[3];
          positions[5] = 0;

          positions[6] = bounds[2];
          positions[7] = bounds[3];
          positions[8] = 0;

          positions[9] = bounds[2];
          positions[10] = bounds[1];
          positions[11] = 0;
        } else {
          // [[minX, minY], [minX, maxY], [maxX, maxY], [maxX, minY]]
          for (var i = 0; i < bounds.length; i++) {
            positions[i * 3 + 0] = bounds[i][0];
            positions[i * 3 + 1] = bounds[i][1];
            positions[i * 3 + 2] = bounds[i][2] || 0;
          }
        }

        return positions;
      }
    }, {
      key: '_getModel',
      value: function _getModel(gl) {
        if (!gl) {
          return null;
        }

        /*
          0,1 --- 1,1
           |       |
          0,0 --- 1,0
        */
        return new luma_gl.Model(gl, Object.assign({}, this.getShaders(), {
          id: this.props.id,
          shaderCache: this.context.shaderCache,
          geometry: new luma_gl.Geometry({
            drawMode: GL.TRIANGLE_FAN,
            vertexCount: 4,
            attributes: {
              texCoords: new Float32Array([0, 0, 0, 1, 1, 1, 1, 0])
            }
          }),
          isInstanced: false
        }));
      }
    }, {
      key: 'draw',
      value: function draw(_ref2) {
        var uniforms = _ref2.uniforms;
        var _state = this.state,
            bitmapTexture = _state.bitmapTexture,
            model = _state.model;
        var _props = this.props,
            desaturate = _props.desaturate,
            transparentColor = _props.transparentColor,
            tintColor = _props.tintColor,
            zoom = _props.zoom,
            decodeParams = _props.decodeParams,
            opacity = _props.opacity;

        // // TODO fix zFighting
        // Render the image

        if (bitmapTexture && model) {
          model.setUniforms(Object.assign({}, uniforms, _extends({
            bitmapTexture: bitmapTexture,
            desaturate: desaturate,
            transparentColor: transparentColor,
            tintColor: tintColor,
            zoom: zoom
          }, decodeParams, {
            opacity: opacity
          }))).draw();
        }
      }
    }, {
      key: 'loadTexture',
      value: function loadTexture(image) {
        var _this2 = this;

        if (typeof image === 'string') {
          image = images.loadImage(image);
        }
        if (image instanceof Promise) {
          image.then(function (data) {
            return _this2.loadTexture(data);
          });
          return;
        }

        var gl = this.context.gl;


        if (this.state.bitmapTexture) {
          this.state.bitmapTexture.delete();
        }

        if (image instanceof luma_gl.Texture2D) {
          this.setState({ bitmapTexture: image });
        } else if (
        // browser object
        image instanceof Image || image instanceof HTMLCanvasElement) {
          this.setState({
            bitmapTexture: new luma_gl.Texture2D(gl, {
              data: image,
              parameters: DEFAULT_TEXTURE_PARAMETERS,
              mipmaps: false
            })
          });
        }
      }
    }, {
      key: 'calculatePositions',
      value: function calculatePositions(_ref3) {
        var value = _ref3.value;
        var positions = this.state.positions;

        value.set(positions);
      }
    }, {
      key: 'calculatePositions64xyLow',
      value: function calculatePositions64xyLow(attribute) {
        var isFP64 = this.use64bitPositions();
        attribute.constant = !isFP64;

        if (!isFP64) {
          attribute.value = new Float32Array(4);
          return;
        }

        var value = attribute.value;

        value.set(this.state.positions.map(fp64LowPart));
      }
    }]);
    return BitmapLayer;
  }(core.Layer);


  BitmapLayer.layerName = 'BitmapLayer';
  BitmapLayer.defaultProps = defaultProps;

  var Tile = function () {
    function Tile(_ref) {
      var getTileData = _ref.getTileData,
          x = _ref.x,
          y = _ref.y,
          z = _ref.z,
          onGetTileDataError = _ref.onGetTileDataError;
      classCallCheck(this, Tile);

      this.x = x;
      this.y = y;
      this.z = z;
      this.isVisible = true;
      this.getTileData = getTileData;
      this._data = null;
      this._isLoaded = false;
      this._loader = this._loadData();
      this.onGetTileDataError = onGetTileDataError;
    }

    createClass(Tile, [{
      key: "_loadData",
      value: function _loadData() {
        var _this = this;

        var x = this.x,
            y = this.y,
            z = this.z;

        if (!this.getTileData) {
          return null;
        }
        var getTileDataPromise = this.getTileData({ x: x, y: y, z: z });
        return getTileDataPromise.then(function (buffers) {
          _this._data = buffers;
          _this._isLoaded = true;
          return buffers;
        }).catch(function (err) {
          _this._isLoaded = true;
          _this.onGetTileDataError(err);
        });
      }
    }, {
      key: "isOverlapped",
      value: function isOverlapped(tile) {
        var x = this.x,
            y = this.y,
            z = this.z;

        var m = Math.pow(2, tile.z - z);
        return Math.floor(tile.x / m) === x && Math.floor(tile.y / m) === y;
      }
    }, {
      key: "data",
      get: function get$$1() {
        if (this._data) {
          return Promise.resolve(this._data);
        }
        return this._loader;
      }
    }, {
      key: "isLoaded",
      get: function get$$1() {
        return this._isLoaded;
      }
    }]);
    return Tile;
  }();

  var TILE_SIZE = 256;

  function getBoundingBox(viewport) {
    var corners = [viewport.unproject([0, 0]), viewport.unproject([viewport.width, 0]), viewport.unproject([0, viewport.height]), viewport.unproject([viewport.width, viewport.height])];

    return [corners.reduce(function (minLng, p) {
      return minLng < p[0] ? minLng : p[0];
    }, 180), corners.reduce(function (minLat, p) {
      return minLat < p[1] ? minLat : p[1];
    }, 90), corners.reduce(function (maxLng, p) {
      return maxLng > p[0] ? maxLng : p[0];
    }, -180), corners.reduce(function (maxLat, p) {
      return maxLat > p[1] ? maxLat : p[1];
    }, -90)];
  }

  function pixelsToTileIndex(a) {
    return Math.floor(a / TILE_SIZE);
  }

  /**
   * Returns all tile indices in the current viewport. If the current zoom level is smaller
   * than minZoom, return an empty array. If the current zoom level is greater than maxZoom,
   * return tiles that are on maxZoom.
   */
  function getTileIndices(viewport, maxZoom, minZoom) {
    var z = Math.floor(viewport.zoom) + 1;
    if (minZoom && z < minZoom) {
      return [];
    }

    viewport = new viewport.constructor(_extends({}, viewport, {
      zoom: z - 1
    }));

    var bbox = getBoundingBox(viewport);

    var _lngLatToWorld$map = viewportMercatorProject.lngLatToWorld([bbox[0], bbox[3]], viewport.scale).map(pixelsToTileIndex),
        _lngLatToWorld$map2 = slicedToArray(_lngLatToWorld$map, 2),
        minX = _lngLatToWorld$map2[0],
        minY = _lngLatToWorld$map2[1];

    var _lngLatToWorld$map3 = viewportMercatorProject.lngLatToWorld([bbox[2], bbox[1]], viewport.scale).map(pixelsToTileIndex),
        _lngLatToWorld$map4 = slicedToArray(_lngLatToWorld$map3, 2),
        maxX = _lngLatToWorld$map4[0],
        maxY = _lngLatToWorld$map4[1];

    var indices = [];

    for (var x = minX; x <= maxX; x++) {
      for (var y = minY; y <= maxY; y++) {
        if (maxZoom && z > maxZoom) {
          indices.push(getAdjustedTileIndex({ x: x, y: y, z: z }, maxZoom));
        } else {
          indices.push({ x: x, y: y, z: z });
        }
      }
    }
    return indices;
  }

  /**
   * Calculates and returns a new tile index {x, y, z}, with z being the given adjustedZ.
   */
  function getAdjustedTileIndex(_ref, adjustedZ) {
    var x = _ref.x,
        y = _ref.y,
        z = _ref.z;

    var m = Math.pow(2, z - adjustedZ);
    return {
      x: Math.floor(x / m),
      y: Math.floor(y / m),
      z: adjustedZ
    };
  }

  /**
   * Manages loading and purging of tiles data. This class caches recently visited tiles
   * and only create new tiles if they are present.
   */

  var TileCache = function () {
    /**
     * Takes in a function that returns tile data, a cache size, and a max and a min zoom level.
     * Cache size defaults to 5 * number of tiles in the current viewport
     */
    function TileCache(_ref) {
      var getTileData = _ref.getTileData,
          maxSize = _ref.maxSize,
          maxZoom = _ref.maxZoom,
          minZoom = _ref.minZoom,
          onGetTileDataError = _ref.onGetTileDataError;
      classCallCheck(this, TileCache);

      // TODO: Instead of hardcode size, we should calculate how much memory left
      this._getTileData = getTileData;
      this._maxSize = maxSize;
      this.onGetTileDataError = onGetTileDataError;

      // Maps tile id in string {z}-{x}-{y} to a Tile object
      this._cache = new Map();

      if (maxZoom && parseInt(maxZoom, 10) === maxZoom) {
        this._maxZoom = maxZoom;
      }
      if (minZoom && parseInt(minZoom, 10) === minZoom) {
        this._minZoom = minZoom;
      }
    }

    /**
     * Clear the current cache
     */


    createClass(TileCache, [{
      key: 'finalize',
      value: function finalize() {
        this._cache.clear();
      }

      /**
       * Update the cache with the given viewport and triggers callback onUpdate.
       * @param {*} viewport
       * @param {*} onUpdate
       */

    }, {
      key: 'update',
      value: function update(viewport, onUpdate) {
        var _cache = this._cache,
            _getTileData = this._getTileData,
            _maxSize = this._maxSize,
            _maxZoom = this._maxZoom,
            _minZoom = this._minZoom;

        this._markOldTiles();
        var tileIndices = getTileIndices(viewport, _maxZoom, _minZoom);
        if (!tileIndices || tileIndices.length === 0) {
          onUpdate(tileIndices);
          return;
        }
        var viewportTiles = new Set();
        _cache.forEach(function (cachedTile) {
          if (tileIndices.some(function (tile) {
            return cachedTile.isOverlapped(tile);
          })) {
            cachedTile.isVisible = true;
            viewportTiles.add(cachedTile);
          }
        });

        for (var i = 0; i < tileIndices.length; i++) {
          var tileIndex = tileIndices[i];

          var x = tileIndex.x,
              y = tileIndex.y,
              z = tileIndex.z;

          var tile = this._getTile(x, y, z);
          if (!tile) {
            tile = new Tile({
              getTileData: _getTileData,
              x: x,
              y: y,
              z: z,
              onGetTileDataError: this.onGetTileDataError
            });
          }
          var tileId = this._getTileId(x, y, z);
          _cache.set(tileId, tile);
          viewportTiles.add(tile);
        }

        // cache size is either the user defined maxSize or 5 * number of current tiles in the viewport.
        var commonZoomRange = 5;
        this._resizeCache(_maxSize || commonZoomRange * tileIndices.length);
        // sort by zoom level so parents tiles don't show up when children tiles are rendered
        var viewportTilesArray = Array.from(viewportTiles).sort(function (t1, t2) {
          return t1.z - t2.z;
        });
        onUpdate(viewportTilesArray);
      }

      /**
       * Clear tiles that are not visible when the cache is full
       */

    }, {
      key: '_resizeCache',
      value: function _resizeCache(maxSize) {
        var _cache = this._cache;

        if (_cache.size > maxSize) {
          var iterator = _cache[Symbol.iterator]();
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = iterator[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var cachedTile = _step.value;

              if (_cache.size <= maxSize) {
                break;
              }
              var tileId = cachedTile[0];
              var tile = cachedTile[1];
              if (!tile.isVisible) {
                _cache.delete(tileId);
              }
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }
        }
      }
    }, {
      key: '_markOldTiles',
      value: function _markOldTiles() {
        this._cache.forEach(function (cachedTile) {
          cachedTile.isVisible = false;
        });
      }
    }, {
      key: '_getTile',
      value: function _getTile(x, y, z) {
        var tileId = this._getTileId(x, y, z);
        return this._cache.get(tileId);
      }
    }, {
      key: '_getTileId',
      value: function _getTileId(x, y, z) {
        return z + '-' + x + '-' + y;
      }
    }]);
    return TileCache;
  }();

  /* eslint-disable no-param-reassign,no-restricted-properties,class-methods-use-this,no-underscore-dangle */

  var defaultProps$1 = {
    renderSubLayers: function renderSubLayers(props) {
      return new BitmapLayer(props);
    },
    getTileData: function getTileData() {
      return (/* { x, y, z } */Promise.resolve(null)
      );
    },
    onDataLoaded: function onDataLoaded() {},
    // eslint-disable-next-line
    onGetTileDataError: function onGetTileDataError(err) {
      return console.error(err);
    },
    maxZoom: null,
    minZoom: null,
    maxCacheSize: null
  };

  var TileLayer = function (_CompositeLayer) {
    inherits(TileLayer, _CompositeLayer);

    function TileLayer() {
      classCallCheck(this, TileLayer);
      return possibleConstructorReturn(this, (TileLayer.__proto__ || Object.getPrototypeOf(TileLayer)).apply(this, arguments));
    }

    createClass(TileLayer, [{
      key: 'initializeState',
      value: function initializeState() {
        var _props = this.props,
            maxZoom = _props.maxZoom,
            minZoom = _props.minZoom,
            getTileData = _props.getTileData,
            onGetTileDataError = _props.onGetTileDataError;

        this.state = {
          tiles: [],
          tileCache: new TileCache({ getTileData: getTileData, maxZoom: maxZoom, minZoom: minZoom, onGetTileDataError: onGetTileDataError }),
          isLoaded: false
        };
      }
    }, {
      key: 'shouldUpdateState',
      value: function shouldUpdateState(_ref) {
        var changeFlags = _ref.changeFlags;

        return changeFlags.somethingChanged;
      }
    }, {
      key: 'updateState',
      value: function updateState(_ref2) {
        var _this2 = this;

        var props = _ref2.props,
            context = _ref2.context,
            changeFlags = _ref2.changeFlags;
        var onDataLoaded = props.onDataLoaded,
            onGetTileDataError = props.onGetTileDataError;

        if (changeFlags.updateTriggersChanged && (changeFlags.updateTriggersChanged.all || changeFlags.updateTriggersChanged.getTileData)) {
          var getTileData = props.getTileData,
              maxZoom = props.maxZoom,
              minZoom = props.minZoom,
              maxCacheSize = props.maxCacheSize;

          this.state.tileCache.finalize();
          this.setState({
            tileCache: new TileCache({
              getTileData: getTileData,
              maxSize: maxCacheSize,
              maxZoom: maxZoom,
              minZoom: minZoom,
              onGetTileDataError: onGetTileDataError
            })
          });
        }
        if (changeFlags.viewportChanged) {
          var viewport = context.viewport;

          var z = this.getLayerZoomLevel();
          if (viewport.id !== 'DEFAULT-INITIAL-VIEWPORT') {
            this.state.tileCache.update(viewport, function (tiles) {
              var currTiles = tiles.filter(function (tile) {
                return tile.z === z;
              });
              var allCurrTilesLoaded = currTiles.every(function (tile) {
                return tile.isLoaded;
              });
              _this2.setState({ tiles: tiles, isLoaded: allCurrTilesLoaded });
              if (!allCurrTilesLoaded) {
                Promise.all(currTiles.map(function (tile) {
                  return tile.data;
                })).then(function () {
                  _this2.setState({ isLoaded: true });
                  onDataLoaded(currTiles.filter(function (tile) {
                    return tile._data;
                  }).map(function (tile) {
                    return tile._data;
                  }));
                });
              } else {
                onDataLoaded(currTiles.filter(function (tile) {
                  return tile._data;
                }).map(function (tile) {
                  return tile._data;
                }));
              }
            });
          }
        }
      }
    }, {
      key: 'getPickingInfo',
      value: function getPickingInfo(_ref3) {
        var info = _ref3.info,
            sourceLayer = _ref3.sourceLayer;

        info.sourceLayer = sourceLayer;
        info.tile = sourceLayer.props.tile;
        return info;
      }
    }, {
      key: 'getLayerZoomLevel',
      value: function getLayerZoomLevel() {
        var z = Math.floor(this.context.viewport.zoom) + 1;
        var _props2 = this.props,
            maxZoom = _props2.maxZoom,
            minZoom = _props2.minZoom;

        if (maxZoom && parseInt(maxZoom, 10) === maxZoom && z > maxZoom) {
          return maxZoom;
        }
        if (minZoom && parseInt(minZoom, 10) === minZoom && z < minZoom) {
          return minZoom;
        }
        return z;
      }
    }, {
      key: 'tile2long',
      value: function tile2long(x, z) {
        return x / Math.pow(2, z) * 360 - 180;
      }
    }, {
      key: 'tile2lat',
      value: function tile2lat(y, z) {
        var n = Math.PI - 2 * Math.PI * y / Math.pow(2, z);
        return 180 / Math.PI * Math.atan(0.5 * (Math.exp(n) - Math.exp(-n)));
      }
    }, {
      key: 'renderLayers',
      value: function renderLayers() {
        var _this3 = this;

        var _props3 = this.props,
            decodeParams = _props3.decodeParams,
            decodeFunction = _props3.decodeFunction,
            opacity = _props3.opacity;

        var zoomLevel = this.getLayerZoomLevel();

        return this.state.tiles.map(function (tile) {
          var x = tile.x,
              y = tile.y,
              z = tile.z,
              _data = tile._data;


          if (_data && _data.src) {
            // Supported formats:
            // - Coordinates of the bounding box of the bitmap `[minX, minY, maxX, maxY]`
            // - Coordinates of four corners of the bitmap, should follow the sequence of `[[minX, minY], [minX, maxY], [maxX, maxY], [maxX, minY]]`
            // each position could be `[x, y]` or `[x, y, z]` format.

            var topLeft = [_this3.tile2long(x, z), _this3.tile2lat(y, z)];
            var topRight = [_this3.tile2long(x + 1, z), _this3.tile2lat(y, z)];
            var bottomLeft = [_this3.tile2long(x, z), _this3.tile2lat(y + 1, z)];
            var bottomRight = [_this3.tile2long(x + 1, z), _this3.tile2lat(y + 1, z)];
            var bounds = [bottomLeft, topLeft, topRight, bottomRight];

            return new BitmapLayer({
              id: _this3.id + '-' + x + '-' + y + '-' + z,
              image: _data.src,
              bounds: bounds,
              visible: z === zoomLevel,
              zoom: zoomLevel,
              decodeParams: decodeParams,
              decodeFunction: decodeFunction,
              opacity: opacity
            });
          }
          return null;
        });
      }
    }]);
    return TileLayer;
  }(deck_gl.CompositeLayer);


  TileLayer.layerName = 'TileLayer';
  TileLayer.defaultProps = defaultProps$1;

  var _getTileData = function _getTileData(_ref, url) {
    var x = _ref.x,
        y = _ref.y,
        z = _ref.z;

    var mapSource = url.replace('{z}', z).replace('{x}', x).replace('{y}', y);

    return fetch(mapSource).then(function (response) {
      return response.blob();
    }).then(function (response) {
      var _ref2 = response || {},
          type = _ref2.type;

      if (type !== 'application/xml' && type !== 'text/xml' && type !== 'text/html') {
        var src = URL.createObjectURL(response);
        var image = new Image();

        image.src = src;
        return image;
      }

      return false;
    });
  };

  var RasterLayer = function RasterLayer(layerModel) {
    var layerConfig = layerModel.layerConfig,
        params = layerModel.params,
        sqlParams = layerModel.sqlParams,
        decodeParams = layerModel.decodeParams,
        id = layerModel.id,
        opacity = layerModel.opacity,
        decodeFunction = layerModel.decodeFunction;


    var layerConfigParsed = layerConfig.parse === false ? layerConfig : JSON.parse(replace(JSON.stringify(layerConfig), params, sqlParams));
    var tileUrl = void 0;

    var _ref3 = layerConfigParsed || {},
        body = _ref3.body,
        url = _ref3.url;

    var _ref4 = body || {},
        paint = _ref4.paint,
        minzoom = _ref4.minzoom,
        maxzoom = _ref4.maxzoom;

    switch (layerModel.provider) {
      case 'gee':
        tileUrl = url || body.url || 'https://api.resourcewatch.org/v1/layer/' + id + '/tile/gee/{z}/{x}/{y}';
        break;
      default:
        tileUrl = url || body.url;
        break;
    }

    var layer = {};

    // if decoded layer use custom deck layer
    if (decodeFunction) {
      layer = {
        id: id,
        type: 'custom',
        layers: [_extends({
          id: id + '-raster-decode-bg',
          type: 'background',
          paint: {
            'background-color': 'transparent'
          }
        }, maxzoom && {
          maxzoom: maxzoom
        }, minzoom && {
          minzoom: minzoom
        }), new mapbox.MapboxLayer({
          id: id + '-raster-decode',
          type: TileLayer,
          minZoom: minzoom,
          maxZoom: maxzoom,
          getTileData: function getTileData(e) {
            return _getTileData(e, url || body.url);
          },
          opacity: layerModel.opacity,
          decodeParams: decodeParams,
          decodeFunction: decodeFunction
        })]
      };
    } else {
      layer = {
        id: id,
        type: 'raster',
        source: {
          type: 'raster',
          tiles: [tileUrl],
          tileSize: 256
        },
        layers: [_extends({
          id: id + '-raster',
          type: 'raster',
          source: id
        }, maxzoom && {
          maxzoom: maxzoom
        }, minzoom && {
          minzoom: minzoom
        }, {
          paint: _extends({}, paint, {
            'raster-opacity': opacity || 1
          })
        })]
      };
    }

    if (layerModel.provider === 'cartodb') {
      return new CancelablePromise(function (resolve, reject) {
        fetchTile(layerModel).then(function (response) {
          tileUrl = response.cdn_url.templates.https.url.replace('{s}', 'a') + '/' + layerConfigParsed.account + '/api/v1/map/' + response.layergroupid + '/{z}/{x}/{y}.png';

          return resolve(_extends({}, layer, {
            source: _extends({}, layer.source, {
              tiles: [tileUrl]
            })
          }));
        }).catch(function (err) {
          return reject(err);
        });
      });
    }

    return new CancelablePromise(function (resolve, reject) {
      if (layer) {
        resolve(layer);
      } else {
        reject(new Error('error in layer config'));
      }
    });
  };

  /**
   * Parsed vector style layers that follow the mapbox style layer spec
   * and returns mountable layers with ids and opacity applied
   * @param {Array} vectorLayers
   * @param {Object} layerModel
   */
  var getVectorStyleLayers = function getVectorStyleLayers(vectorLayers, layerModel) {
    var id = layerModel.id,
        params = layerModel.params,
        sqlParams = layerModel.sqlParams;

    if (vectorLayers && vectorLayers.length) {
      var vectorLayersParsed = JSON.parse(replace(JSON.stringify(vectorLayers), params, sqlParams));
      return vectorLayersParsed && vectorLayersParsed.map(function (vectorLayer, i) {
        var PAINT_STYLE_NAMES = {
          symbol: ['icon', 'text'],
          circle: ['circle', 'circle-stroke']
        };

        // Select the paint property from the original layer
        var _vectorLayer$paint = vectorLayer.paint,
            paint = _vectorLayer$paint === undefined ? {} : _vectorLayer$paint;

        // Select the style to change depending on the type of layer

        var opacityPaintNames = PAINT_STYLE_NAMES[vectorLayer.type] || [vectorLayer.type];

        var opacityPaintStyles = opacityPaintNames.reduce(function (obj, name) {
          var currentProperty = paint[name + '-opacity'];

          var paintOpacity = currentProperty !== undefined && currentProperty !== null ? currentProperty : 1;
          return _extends({}, obj, defineProperty({}, name + '-opacity', paintOpacity * layerModel.opacity * 0.99));
        }, {});

        // if paint properties are null are passed it breaks interaction
        // on mapbox. We need to remove these
        var filteredPaintProperties = vectorLayer.paint && Object.entries(vectorLayer.paint).reduce(function (obj, _ref) {
          var _ref2 = slicedToArray(_ref, 2),
              key = _ref2[0],
              value = _ref2[1];

          return _extends({}, obj, !!value && defineProperty({}, key, value));
        }, {});

        return _extends({
          // id: This will avoid having issues with any layer, but you should specify an id when you create it.
          // If you don't set an id in the definition, and you set a fill-opacity, it won't work
          id: id + '-' + vectorLayer.type + '-' + i
        }, vectorLayer, {
          source: id
        }, vectorLayer.paint && {
          paint: _extends({}, filteredPaintProperties, opacityPaintStyles)
        });
      });
    }

    return false;
  };

  var VectorLayer = function VectorLayer(layerModel) {
    var layerConfig = layerModel.layerConfig,
        params = layerModel.params,
        sqlParams = layerModel.sqlParams,
        id = layerModel.id;


    var layerConfigParsed = layerConfig.parse === false ? layerConfig : JSON.parse(replace(JSON.stringify(layerConfig), params, sqlParams));

    var _ref = layerConfigParsed || {},
        body = _ref.body,
        url = _ref.url;

    var _ref2 = body || {},
        vectorLayers = _ref2.vectorLayers;

    var layer = {
      id: id,
      source: _extends({
        type: 'vector'
      }, (url || body && body.url) && {
        url: layerConfigParsed.url || layerConfigParsed.body.url
      }),
      layers: vectorLayers ? getVectorStyleLayers(vectorLayers, layerModel) : [{
        id: id + '-fill-0',
        source: id,
        type: 'fill',
        'source-layer': 'layer0',
        paint: {
          'fill-opacity': layerModel.opacity * 0.5 || 0.5,
          'fill-color': '#f69'
        }
      }, {
        id: id + '-line-0',
        source: id,
        type: 'line',
        'source-layer': 'layer0',
        paint: {
          'line-opacity': layerModel.opacity || 1,
          'line-color': '#f69'
        }
      }, {
        id: id + '-circle-0',
        source: id,
        type: 'circle',
        'source-layer': 'layer0',
        paint: {
          'circle-opacity': layerModel.opacity || 1,
          'circle-color': '#f69'
        }
      }]
    };

    if (layerModel.provider === 'cartodb') {
      return new CancelablePromise(function (resolve, reject) {
        fetchTile(layerModel).then(function (response) {
          var tileUrl = response.cdn_url.templates.https.url.replace('{s}', 'a') + '/' + layerConfigParsed.account + '/api/v1/map/' + response.layergroupid + '/{z}/{x}/{y}.mvt';

          return resolve(_extends({}, layer, {
            source: _extends({}, layer.source, {
              tiles: [tileUrl]
            })
          }));
        }).catch(function (err) {
          return reject(err);
        });
      });
    }

    return new CancelablePromise(function (resolve, reject) {
      if (layer) {
        resolve(layer);
      } else {
        reject(new Error('error in layer config'));
      }
    });
  };

  var GeoJsonLayer = function GeoJsonLayer(layerModel) {
    var layerConfig = layerModel.layerConfig,
        params = layerModel.params,
        sqlParams = layerModel.sqlParams,
        id = layerModel.id,
        decodeGeoJson = layerModel.decodeGeoJson;


    var layerConfigParsed = layerConfig.parse === false ? layerConfig : JSON.parse(replace(JSON.stringify(layerConfig), params, sqlParams));

    var _ref = layerConfigParsed || {},
        data = _ref.data,
        body = _ref.body,
        type = _ref.type;

    var _ref2 = body || {},
        url = _ref2.url,
        vectorLayers = _ref2.vectorLayers,
        clusterConfig = _ref2.clusterConfig;

    var layer = {};

    if (['markers', 'cluster'].includes(type)) {
      layer = {
        id: id,
        source: _extends({
          type: 'geojson',
          data: url || data
        }, clusterConfig),
        layers: vectorLayers ? getVectorStyleLayers(vectorLayers, layerModel) : [{
          id: id + '-clusters',
          type: 'circle',
          source: id,
          filter: ['has', 'point_count'],
          paint: {
            'circle-color': '#f69',
            'circle-radius': 12
          }
        }, {
          id: id + '-cluster-count',
          type: 'symbol',
          source: id,
          filter: ['has', 'point_count'],
          layout: {
            'text-field': '{point_count_abbreviated}',
            'text-size': 12
          }
        }, {
          id: id + '-unclustered-point',
          type: 'circle',
          source: id,
          filter: ['!', ['has', 'point_count']],
          paint: {
            'circle-color': '#f69',
            'circle-radius': 12
          }
        }]
      };
    } else {
      layer = {
        id: id,
        source: {
          type: 'geojson',
          data: url || data
        },
        layers: vectorLayers ? getVectorStyleLayers(vectorLayers, layerModel) : [{
          id: id + '-fill',
          type: 'fill',
          source: id,
          paint: {
            'fill-color': 'blue'
          }
        }, {
          id: id + '-line',
          type: 'line',
          source: id,
          paint: {
            'line-color': '#000',
            'line-width': 2
          }
        }]
      };
    }

    if (decodeGeoJson) {
      return new CancelablePromise(function (resolve, reject) {
        fetchData(layerModel).then(function (response) {
          var features = decodeGeoJson(response);
          var layerWithData = _extends({}, layer, {
            source: _extends({}, layer.source, {
              data: {
                type: 'FeatureCollection',
                features: features
              }
            })
          });
          resolve(layerWithData);
        }).catch(function (err) {
          return reject(err);
        });
      });
    }

    return new CancelablePromise(function (resolve, reject) {
      if (layer) {
        resolve(layer);
      } else {
        reject(new Error('"type" specified in layer spec doesn`t exist'));
      }
    });
  };

  /* eslint-disable no-underscore-dangle */

  var PluginMapboxGL = function () {
    function PluginMapboxGL(map, options) {
      var _this = this;

      classCallCheck(this, PluginMapboxGL);
      this.provider = {
        leaflet: RasterLayer,
        gee: RasterLayer,
        cartodb: VectorLayer,
        mapbox: VectorLayer,
        geojson: GeoJsonLayer
      };
      this.type = {
        raster: RasterLayer,
        vector: VectorLayer,
        geojson: GeoJsonLayer
      };

      this.map = map;
      this.options = options;

      // You can change mapStyles and all the layers will be repositioned
      this.map.on('style.load', function () {
        var layers = _this.getLayers();

        layers.forEach(function (layer) {
          return _this.add(layer);
        });
      });
    }

    createClass(PluginMapboxGL, [{
      key: 'add',


      /**
       * Add a layer
       * @param {Object} layerModel
       */
      value: function add(layerModel) {
        var _this2 = this;

        var mapLayer = layerModel.mapLayer;

        var allLayers = this.getLayers();

        // add source if it has one
        if (this.map && mapLayer && mapLayer.source && mapLayer.id && !this.map.getSource(mapLayer.id)) {
          this.map.addSource(mapLayer.id, mapLayer.source);
        }

        // add layers
        if (mapLayer && mapLayer.layers) {
          mapLayer.layers.forEach(function (l) {
            var _l$metadata = l.metadata,
                metadata = _l$metadata === undefined ? {} : _l$metadata;

            var nextLayerId = metadata.position === 'top' ? null : _this2.getNextLayerId(layerModel);

            if (_this2.map && !_this2.map.getLayer(l.id)) {
              _this2.map.addLayer(l, nextLayerId);
            }

            allLayers.forEach(function () {
              _this2.setZIndex();
            });
          });
        }
      }

      /**
       * Remove a layer
       * @param {Object} layerModel
       */

    }, {
      key: 'remove',
      value: function remove() {
        var _this3 = this;

        var layerModel = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var mapLayer = layerModel.mapLayer;

        if (mapLayer && mapLayer.layers && this.map && this.map.style) {
          mapLayer.layers.forEach(function (l) {
            if (l && _this3.map.getLayer(l.id)) {
              _this3.map.removeLayer(l.id);
            }
          });
        }

        if (this.map && this.map.getSource(mapLayer.id)) {
          this.map.removeSource(mapLayer.id);
        }
      }

      /**
       * Get method by provider
       * @param {String} provider
       */

    }, {
      key: 'getLayerByProvider',
      value: function getLayerByProvider(provider, layerModel) {
        // required to maintain current layerSpec without creating a breaking change
        if (provider === 'leaflet' && layerModel.layerConfig.type === 'cluster') {
          return this.provider.geojson;
        }
        return this.provider[provider];
      }

      /**
       * Get method by type
       * @param {String} type
       */

    }, {
      key: 'getLayerByType',
      value: function getLayerByType(type) {
        return this.type[type];
      }

      /**
       * Get all mapbox layers
       */

    }, {
      key: 'getLayersOnMap',
      value: function getLayersOnMap() {
        return this.map.getStyle().layers;
      }

      /**
       * Get all layers passed to layer manager
       */

    }, {
      key: 'getLayers',
      value: function getLayers() {
        var getLayers = this.options.getLayers;

        var layers = getLayers();
        return sortBy(layers, function (l) {
          return l.decodeFunction;
        });
      }

      /**
       * Get the layer above the given z-index
       * @param {Object} layerModel
       */

    }, {
      key: 'getNextLayerId',
      value: function getNextLayerId(layerModel) {
        var zIndex = layerModel.zIndex;

        var allLayers = this.getLayers();
        var layersOnMap = this.getLayersOnMap();

        // find the top layer for placing data layers below
        var customLayer = layersOnMap && layersOnMap.length && layersOnMap.find(function (l) {
          return l.id.includes('custom-layers') || l.id.includes('label') || l.id.includes('place') || l.id.includes('poi');
        });

        // make sure layers are sorted by zIndex
        var sortedLayers = sortBy(allLayers, function (l) {
          return l.zIndex;
        });

        // get the layer with zIndex greater than current layer from all layers
        var nextLayer = sortedLayers.find(function (l) {
          return l.zIndex > zIndex && (!l.mapLayer || !l.mapLayer.layers || !l.mapLayer.layers[0] || !l.mapLayer.layers[0].metadata || !l.mapLayer.layers[0].metadata.position);
        });

        // if no layer above it then use the custom layer
        if (!nextLayer || !!nextLayer && !nextLayer.mapLayer) {
          return customLayer.id;
        }

        // get the first layer of the next layer's array
        var nextLayerMapLayers = nextLayer.mapLayer.layers;
        var nextLayerMapLayer = nextLayerMapLayers[0];

        // Filter layers with custom metadata position
        var id = nextLayerMapLayer.id;

        // if it has a layer above it, check if that layer has been added to the map and get its id

        var isNextLayerOnMap = !!layersOnMap.find(function (l) {
          return id === l.id;
        });

        // if next layer is on map return the id, else return the custom layer to add below
        return isNextLayerOnMap ? id : customLayer.id;
      }

      /**
       * A namespace to set z-index
       * @param {Object} layerModel
       */

    }, {
      key: 'setZIndex',
      value: function setZIndex() {
        var _this4 = this;

        var allLayers = this.getLayers();
        var layersOnMap = this.getLayersOnMap();

        // set zIndex for all layers currently on map
        layersOnMap.forEach(function (l) {
          var id = l.id,
              _l$metadata2 = l.metadata,
              metadata = _l$metadata2 === undefined ? {} : _l$metadata2;

          var layerModel = allLayers.find(function (ly) {
            return id.includes(ly.id);
          });

          if (layerModel) {
            var nextLayerId = metadata.position === 'top' ? null : _this4.getNextLayerId(layerModel);
            _this4.map.moveLayer(id, nextLayerId);
          }
        });

        // set for all decode layers that don't exist inside mapStyle()
        var decodeLayers = allLayers.filter(function (l) {
          return !!l.decodeFunction;
        });

        if (decodeLayers && this.map) {
          decodeLayers.forEach(function (layerModel) {
            var mapLayer = layerModel.mapLayer;


            if (mapLayer) {
              var layers = mapLayer.layers;

              var parentLayer = layers[0];
              var childLayer = layers[1];

              var parentLayerOnMap = layersOnMap.find(function (ly) {
                return ly.id === parentLayer.id;
              });
              var childLayerOnMap = _this4.map.getLayer(childLayer.id);

              if (parentLayerOnMap && childLayerOnMap) {
                _this4.map.moveLayer(childLayer.id, parentLayer.id);
              }
            }
          });
        }

        return true;
      }

      /**
       * A namespace to set opacity
       * @param {Object} layerModel
       * @param {Number} opacity
       */

    }, {
      key: 'setOpacity',
      value: function setOpacity(layerModel, opacity) {
        var _this5 = this;

        var PAINT_STYLE_NAMES = {
          symbol: ['icon', 'text'],
          circle: ['circle', 'circle-stroke']
        };

        var layerConfig = layerModel.layerConfig,
            mapLayer = layerModel.mapLayer,
            decodeFunction = layerModel.decodeFunction;
        var body = layerConfig.body;
        var _body$vectorLayers = body.vectorLayers,
            vectorLayers = _body$vectorLayers === undefined ? [] : _body$vectorLayers;


        if (mapLayer.layers && !decodeFunction) {
          mapLayer.layers.forEach(function (l) {
            // Select the style to change depending on the type of layer
            var paintStyleNames = PAINT_STYLE_NAMES[l.type] || [l.type];

            // Select the paint property from the original layer

            var _ref = vectorLayers.find(function (v, i) {
              return (v.id || l.source + '-' + v.type + '-' + i) === l.id;
            }) || {},
                _ref$paint = _ref.paint,
                paint = _ref$paint === undefined ? {} : _ref$paint;

            // Loop each style name and check if there is an opacity in the original layer


            paintStyleNames.forEach(function (name) {
              var currentProperty = paint[name + '-opacity'];
              var paintOpacity = currentProperty !== undefined ? currentProperty : 1;
              _this5.map.setPaintProperty(l.id, name + '-opacity', paintOpacity * opacity * 0.99);
            });
          });
        }

        if (decodeFunction) {
          var layer = mapLayer.layers[1];

          if (layer && typeof layer.setProps === 'function') {
            layer.setProps({ opacity: opacity });
          }
        }
      }

      /**
       * A namespace to hide or show a selected layer
       * @param {Object} layerModel
       * @param {Boolean} visibility
       */

    }, {
      key: 'setVisibility',
      value: function setVisibility(layerModel, visibility) {
        var _this6 = this;

        var mapLayer = layerModel.mapLayer;


        if (mapLayer && mapLayer.layers && this.map && this.map.style) {
          mapLayer.layers.forEach(function (l) {
            _this6.map.setLayoutProperty(l.id, 'visibility', visibility ? 'visible' : 'none');
          });
        }
      }
    }, {
      key: 'setParams',
      value: function setParams(layerModel) {
        this.remove(layerModel);
      }
    }, {
      key: 'setSQLParams',
      value: function setSQLParams(layerModel) {
        this.remove(layerModel);
      }
    }, {
      key: 'setLayerConfig',
      value: function setLayerConfig(layerModel) {
        this.remove(layerModel);
      }
    }, {
      key: 'setDecodeParams',
      value: function setDecodeParams(layerModel) {
        var mapLayer = layerModel.mapLayer,
            decodeParams = layerModel.decodeParams;


        if (!mapLayer) {
          return this;
        }

        var layer = mapLayer.layers[1];

        if (layer && typeof layer.setProps === 'function') {
          layer.setProps({ decodeParams: decodeParams });
        } else {
          console.error("Layer is not present. You defined decodeParams but maybe you didn't define a decodeFunction");
        }

        return this;
      }
    }, {
      key: 'unmount',
      value: function unmount() {
        this.map = null;
      }
    }]);
    return PluginMapboxGL;
  }();

  var cartoLayer = (function (Cesium) {
    return function (layerModel) {
      return fetchTile(layerModel).then(function (response) {
        var layerConfig = layerModel.layerConfig;

        var url = response.cdn_url.templates.https.url + '/' + layerConfig.account + '/api/v1/map/' + response.layergroupid + '/{z}/{x}/{y}.png';
        var provider = new Cesium.UrlTemplateImageryProvider({ url: url });
        provider.errorEvent.addEventListener(function () {
          return false;
        });
        // don't show warnings
        return new Cesium.ImageryLayer(provider);
      });
    };
  });

  var tileLayer = (function (Cesium) {
    return function (layerModel) {
      return new Promise(function (resolve) {
        var _layerModel$layerConf = layerModel.layerConfig,
            layerConfig = _layerModel$layerConf === undefined ? {} : _layerModel$layerConf;
        var url = layerConfig.body.url;

        var provider = new Cesium.UrlTemplateImageryProvider({ url: url });
        provider.errorEvent.addEventListener(function () {
          return false;
        });
        // don't show warnings
        resolve(new Cesium.ImageryLayer(provider));
      });
    };
  });

  var PluginCesium = function () {
    function PluginCesium(map) {
      classCallCheck(this, PluginCesium);

      _initialiseProps.call(this);

      var Cesium = PluginCesium.Cesium;

      this.map = map;
      this.eventListener = new Cesium.ScreenSpaceEventHandler(map.scene.canvas);

      this.methods = {
        carto: cartoLayer(Cesium),
        cartodb: cartoLayer(Cesium),
        cesium: tileLayer(Cesium)
      };
    }

    createClass(PluginCesium, [{
      key: 'add',
      value: function add(layerModel) {
        var mapLayer = layerModel.mapLayer;

        this.map.imageryLayers.add(mapLayer);
      }
    }, {
      key: 'remove',
      value: function remove(layerModel) {
        var mapLayer = layerModel.mapLayer;

        this.map.imageryLayers.remove(mapLayer, true);
        this.eventListener.destroy();
      }
    }, {
      key: 'getLayerByProvider',
      value: function getLayerByProvider(provider) {
        return this.methods[provider];
      }
    }, {
      key: 'setZIndex',
      value: function setZIndex(layerModel, zIndex) {
        var length = this.map.imageryLayers.length;
        var mapLayer = layerModel.mapLayer;

        var layerIndex = zIndex >= length ? length - 1 : zIndex;
        var nextIndex = zIndex < 0 ? 0 : layerIndex;
        var currentIndex = this.map.imageryLayers.indexOf(mapLayer);
        if (currentIndex !== nextIndex) {
          var steps = nextIndex - currentIndex;
          for (var i = 0; i < Math.abs(steps); i++) {
            if (steps > 0) {
              this.map.imageryLayers.raise(mapLayer);
            } else {
              this.map.imageryLayers.lower(mapLayer);
            }
          }
        }
        return this;
      }
    }, {
      key: 'setOpacity',
      value: function setOpacity(layerModel, opacity) {
        var mapLayer = layerModel.mapLayer;

        mapLayer.alpha = opacity;
        return this;
      }
    }, {
      key: 'setVisibility',
      value: function setVisibility(layerModel, visibility) {
        var mapLayer = layerModel.mapLayer;

        mapLayer.show = visibility;
        return this;
      }
    }, {
      key: 'setEvents',
      value: function setEvents(layerModel) {
        var _this = this;

        var events = layerModel.events;

        Object.keys(events).forEach(function (type) {
          var action = events[type];
          if (_this.eventListener.getInputAction(type)) {
            _this.eventListener.removeInputAction(type);
          }
          _this.eventListener.setInputAction(_this.getCoordinatesFromEvent(action), type);
        });
        return this;
      }
    }, {
      key: 'setParams',
      value: function setParams(layerModel) {
        this.remove(layerModel);
      }
    }, {
      key: 'setSQLParams',
      value: function setSQLParams(layerModel) {
        this.remove(layerModel);
      }
    }, {
      key: 'setLayerConfig',
      value: function setLayerConfig(layerModel) {
        this.remove(layerModel);
      }
    }, {
      key: 'setDecodeParams',
      value: function setDecodeParams(layerModel) {
        console.info('Decode params callback', layerModel, this);
      }
    }]);
    return PluginCesium;
  }();

  PluginCesium.Cesium = typeof window !== 'undefined' ? window.Cesium : null;

  var _initialiseProps = function _initialiseProps() {
    var _this2 = this;

    this.getCoordinatesFromEvent = function (action) {
      return function (event) {
        var position = event.position;
        var Cesium = PluginCesium.Cesium;

        var clicked = new Cesium.Cartesian2(position.x, position.y);
        var ellipsoid = _this2.map.scene.globe.ellipsoid;

        var cartesian = _this2.map.camera.pickEllipsoid(clicked, ellipsoid);
        if (cartesian) {
          var cartographic = ellipsoid.cartesianToCartographic(cartesian);
          var lat = Cesium.Math.toDegrees(cartographic.latitude);
          var lng = Cesium.Math.toDegrees(cartographic.longitude);
          action(event, { lat: lat, lng: lng });
        }
      };
    };
  };

  var LayerModel = function () {
    function LayerModel() {
      var layerSpec = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      classCallCheck(this, LayerModel);
      this.opacity = 1;
      this.visibility = true;

      Object.assign(this, layerSpec, { changedAttributes: {} });
    }

    createClass(LayerModel, [{
      key: 'get',
      value: function get$$1(key) {
        return this[key];
      }
    }, {
      key: 'set',
      value: function set$$1(key, value) {
        this[key] = value;
        return this;
      }
    }, {
      key: 'update',
      value: function update(layerSpec) {
        var _this = this;

        var prevData = _extends({}, this);
        var nextData = _extends({}, layerSpec);

        // reseting changedAttributes for every update
        this.set('changedAttributes', {});

        Object.keys(nextData).forEach(function (k) {
          if (!isEqual(prevData[k], nextData[k])) {
            _this.changedAttributes[k] = nextData[k];
            _this.set(k, nextData[k]);
          }
        });
      }
    }]);
    return LayerModel;
  }();

  function checkPluginProperties(plugin) {
    if (plugin) {
      var requiredProperties = ['add', 'remove', 'setVisibility', 'setOpacity', 'setZIndex', 'setLayerConfig', 'setParams', 'setSQLParams', 'setDecodeParams', 'getLayerByType'];

      requiredProperties.forEach(function (property) {
        if (!plugin[property]) {
          console.error('The ' + property + ' function is required for layer manager plugins');
        }
      });

      var deprecatedProperties = ['getLayerByProvider'];
      deprecatedProperties.forEach(function (property) {
        if (plugin[property]) {
          console.warn('The ' + property + ' function is deprecated for layer manager plugins');
        }
      });
    }
  }

  var LayerManager = function () {
    function LayerManager(map, Plugin) {
      classCallCheck(this, LayerManager);

      this.map = map;
      this.layers = [];
      this.promises = {};
      this.options = {
        getLayers: this.getLayers.bind(this)
      };

      this.plugin = new Plugin(this.map, this.options);
      checkPluginProperties(this.plugin);
    }

    /**
     * Add layers
     * @param {Array} layers
     * @param {Object} layerOptions
     */


    createClass(LayerManager, [{
      key: 'add',
      value: function add(layer) {
        var layerOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
          opacity: 1,
          visibility: true,
          zIndex: 0,
          interactivity: null
        };

        if (typeof layer === 'undefined') {
          console.error('layer is required');
          return this;
        }

        var layerModel = new LayerModel(_extends({}, layer, layerOptions));
        var id = layerModel.id;


        if (this.layers.find(function (l) {
          return l.id === id;
        })) {
          return this.layers;
        }
        this.layers.push(layerModel);

        this.requestLayer(layerModel);

        return this.layers;
      }

      /**
       * Updating a specific layer
       * @param  {Object} layerModel
       */

    }, {
      key: 'update',
      value: function update(id, changedProps) {
        var layerModel = this.getLayerModel(id);
        if (!layerModel || !layerModel.mapLayer) return;

        layerModel.update(changedProps);

        var opacity = changedProps.opacity,
            visibility = changedProps.visibility,
            zIndex = changedProps.zIndex,
            decodeParams = changedProps.decodeParams;


        if (typeof opacity !== 'undefined') {
          this.plugin.setOpacity(layerModel, opacity);
        }
        if (typeof visibility !== 'undefined') {
          this.plugin.setVisibility(layerModel, visibility);
        }
        if (typeof zIndex !== 'undefined') {
          this.plugin.setZIndex(layerModel, zIndex);
        }

        if (!isEmpty(decodeParams)) {
          this.plugin.setDecodeParams(layerModel);
        }
      }

      /**
       * Remove a layer giving a Layer ID
       * @param {String} id
       */

    }, {
      key: 'remove',
      value: function remove(id) {
        var layers = this.layers.slice(0);

        this.requestCancel(id);

        var layerModel = this.getLayerModel(id);

        if (layerModel) {
          this.plugin.remove(layerModel);
        }

        this.layers = layers.filter(function (l) {
          return l.id !== id;
        });
      }
    }, {
      key: 'getLayers',
      value: function getLayers() {
        return this.layers;
      }
    }, {
      key: 'getLayerModel',
      value: function getLayerModel(id) {
        return this.layers.find(function (l) {
          return l.id === id;
        });
      }

      /**
       * A namespace to set opacity on selected layer
       * @param {String} id
       * @param {Number} opacity
       */

    }, {
      key: 'setOpacity',
      value: function setOpacity(id, opacity) {
        var layerModel = this.getLayerModel(id);
        this.plugin.setOpacity(layerModel, opacity);
      }

      /**
       * A namespace to hide or show a selected layer
       * @param {String} id
       * @param {Boolean} visibility
       */

    }, {
      key: 'setVisibility',
      value: function setVisibility(id, visibility) {
        var layerModel = this.getLayerModel(id);
        this.plugin.setVisibility(layerModel, visibility);
      }

      /**
       * A namespace to set z-index on selected layer
       * @param {String} id
       * @param {Number} zIndex
       */

    }, {
      key: 'setZIndex',
      value: function setZIndex(id, zIndex) {
        var layerModel = this.getLayerModel(id);
        this.plugin.setZIndex(layerModel, zIndex);
      }
    }, {
      key: 'requestLayer',
      value: function requestLayer(layerModel) {
        var _this = this;

        var layerType = layerModel.layerType,
            provider = layerModel.provider;

        var method = this.plugin.getLayerByType(layerType) || this.plugin.getLayerByProvider(provider, layerModel);

        if (!method) {
          this.promises[layerModel.id] = CancelablePromise.reject(new Error(provider + ' provider is not yet supported.'));
          return false;
        }

        // Cancel previous/existing request
        this.requestCancel(layerModel.id);

        // every request method returns a promise that we store in the array
        // to control when all layers are fetched.
        this.promises[layerModel.id] = method.call(this, layerModel).then(function (layer) {
          var canceled = _this.promises[layerModel.id]._canceled;

          if (!canceled) {
            layerModel.set('mapLayer', layer);
            _this.plugin.add(layerModel, _this.layers);
            _this.plugin.setZIndex(layerModel, layerModel.zIndex);
            _this.plugin.setOpacity(layerModel, layerModel.opacity);
            _this.plugin.setVisibility(layerModel, layerModel.visibility);
          }
        });

        return this;
      }
    }, {
      key: 'requestCancel',
      value: function requestCancel(layerModelId) {
        // Cancel previous/existing request
        if (this.promises[layerModelId] && this.promises[layerModelId].cancel) {
          this.promises[layerModelId].cancel();
        }
      }
    }, {
      key: 'unmount',
      value: function unmount() {
        this.map = null;
        this.plugin.unmount();
      }
    }]);
    return LayerManager;
  }();

  // This file exists as an entry point for bundling our umd builds.

  LayerManager.PluginLeaflet = PluginLeaflet;
  LayerManager.PluginCesium = PluginCesium;
  LayerManager.PluginMapboxGl = PluginMapboxGL;
  LayerManager.replace = replace;
  LayerManager.substitution = substitution;
  LayerManager.concatenation = concatenation;

  return LayerManager;

})));
